Blowfish_Process:
	or a
	jr z,Blowfish_Encrypt
	ld a,17
	ld (vI),a
	ld a,-1
	ld (lChange),a
	ld a,1
	ld (lEnd),a
	jr Blowfish_Encrypt_Go
Blowfish_Encrypt:
	xor a
	ld (vI),a
	inc a
	ld (lChange),a
	ld a,16
	ld (lEnd),a
Blowfish_Encrypt_Go:
	;Inputs - HL points to the data to encrypt/decrypt
	;A=0 for encryption, A=1 for decryption
	;Outputs - DE points to where to store the encrypted/decrypted data
	push de
	ld de,xL
	ld bc,8
	ldir
	;xL and xR are set up
Blowfish_Encrypt_Loop:
	ld de,xL
	ld h,99h
	ld a,(vI)
	add a,a
	add a,a		;I*4 to get the offset
	ld l,a
	;HL now is the pointer to P(i)
	;Do the XOR
	ld a,(de)
	xor (hl)
	ld (de),a
	inc de
	inc hl
	ld a,(de)
	xor (hl)
	ld (de),a
	inc de
	inc hl
	ld a,(de)
	xor (hl)
	ld (de),a
	inc de
	inc hl
	ld a,(de)
	xor (hl)
	ld (de),a
	inc de
	inc hl		;xL = xL XOR P(i) complete
	;Next we must first get break up xL into a,b,c,d (one byte each)
	;We do: S1(a) + S2(b)
	ld a,(xL+3)
	ld l,a
	ld h,0
	add hl,hl
	add hl,hl
	ld bc,9E00h
	add hl,bc
	;HL points to the 4 bytes of S1(a)
	ex de,hl
	ld a,(xL+2)
	ld l,a
	ld h,0
	add hl,hl
	add hl,hl
	ld bc,0A200h
	add hl,bc
	ex de,hl
	;DE points to the 4 bytes of S2(b)
	ld a,(de)
	add a,(hl)
	ld (xTemp1),a
	inc de
	inc hl
	ld a,(de)
	adc a,(hl)
	ld (xTemp1+1),a
	inc de
	inc hl
	ld a,(de)
	adc a,(hl)
	ld (xTemp1+2),a
	inc de
	inc hl
	ld a,(de)
	adc a,(hl)
	ld (xTemp1+3),a
	;(xTemp1) now contains S1(a)+S2(b)
	;Must XOR it with S3(c)
	ld de,xTemp1
	ld a,(xL+1)
	ld l,a
	ld h,0
	add hl,hl
	add hl,hl
	ld bc,0A600h
	add hl,bc
	ld a,(de)
	xor (hl)
	ld (de),a
	inc de
	inc hl
	ld a,(de)
	xor (hl)
	ld (de),a
	inc de
	inc hl
	ld a,(de)
	xor (hl)
	ld (de),a
	inc de
	inc hl
	ld a,(de)
	xor (hl)
	ld (de),a
	;(xTemp1) now contains [S1(a)+S2(b) XOR S3(c)]
	;Now add S4(d) to this
	ld a,(xL)
	ld l,a
	ld h,0
	add hl,hl
	add hl,hl
	ld bc,0AA00h
	add hl,bc
	ld de,xTemp1
	ld a,(de)
	add a,(hl)
	ld (de),a
	inc de
	inc hl
	ld a,(de)
	adc a,(hl)
	ld (de),a
	inc de
	inc hl
	ld a,(de)
	adc a,(hl)
	ld (de),a
	inc de
	inc hl
	ld a,(de)
	adc a,(hl)
	ld (de),a
	;(xTemp1) = F(xL)
	;Now XOR with xR
	ld hl,xR
	ld de,xTemp1
	ld a,(de)
	xor (hl)
	ld (de),a
	inc hl
	inc de
	ld a,(de)
	xor (hl)
	ld (de),a
	inc hl
	inc de
	ld a,(de)
	xor (hl)
	ld (de),a
	inc hl
	inc de
	ld a,(de)
	xor (hl)
	ld (de),a
	;xR = F(xL) XOR xR now done
	ld hl,xL
	ld de,xR
	ld bc,4
	ldi
	ldi
	ldi
	ldi
	ld hl,xTemp1
	ld de,xL
	ld bc,4
	ldi
	ldi
	ldi
	ldi
	;Done with swap...now loop up
	ld a,(lEnd)
	ld c,a
	ld a,(vI)
	ld b,a
	ld a,(lChange)
	add a,b
	ld (vI),a
	cp c
	jp nz,Blowfish_Encrypt_Loop
	;Now finish up
	;Must swap xL and xR
	ld hl,xL
	ld de,xTemp1
	ld bc,4
	ldir
	ld hl,xR
	ld de,xL
	ld bc,4
	ldir
	ld hl,xTemp1
	ld de,xR
	ld bc,4
	ldir
	;Now do xR = xR XOR P(17)
	ld a,(lEnd)
	add a,a
	add a,a
	ld h,99h
	ld l,a	;P(17)
	ld de,xR
	ld b,4
Blowfish_Encrypt_XORLoopEnd:
	ld a,(de)
	xor (hl)
	ld (de),a
	inc hl
	inc de
	djnz Blowfish_Encrypt_XORLoopEnd
	;Now do xL = xL XOR P(18)
	ld a,(lEnd)
	ld b,a
	ld a,(lChange)
	add a,b
	ld h,99h
	add a,a
	add a,a
	ld l,a	;P(18)
	ld de,xL
	ld b,4
Blowfish_Encrypt_XORLoopEnd2:
	ld a,(de)
	xor (hl)
	ld (de),a
	inc hl
	inc de
	djnz Blowfish_Encrypt_XORLoopEnd2
	;Now done...
	pop de
	;Put them back
	ld hl,xL
	ld bc,8
	ldir
	ret
Blowfish_Setup:
	ld hl,KeyFile
	rst 20h
	B_CALL ChkFindSym
	jr c,Encrypt_Go_RC6_KeyNotFound
	ld a,b
	or a
	jr z,Blowfish_Setup_KeyLoad
	;Key appvar is archived...Stream to flash
	;A is ROM page
	ex de,hl
	ld de,20
	add hl,de
	bit 7,h
	jr z,Blowfish_Setup_KeyArchivedGo
	res 7,h
	set 6,h
	inc a
Blowfish_Setup_KeyArchivedGo:
	;HL, A are set
	ld de,8000h
	ld bc,32
	B_CALL FlashToRam
	jr Blowfish_Setup_KeyDone
Blowfish_Setup_KeyLoad:
	ex de,hl
	inc hl
	inc hl
	ld de,8000h
	ld bc,32
	ldir
	;Key now copied to RAM at 8000h
Blowfish_Setup_KeyDone:
	;Now 8000h contains the key
	ld hl,106Bh+50
	B_CALL EnoughMem
	jr c,Blowfish_NotEnoughMemory
	ld hl,106Bh
	ld de,9D95h
	B_CALL InsertMem
	;Memory inserted...4K starting at 9E00h
	ld hl,Blowfish_P_Array
	ld de,pArray
	ld bc,72
	ldir
	ld hl,Blowfish_S_Box1
	ld de,SBox_1
	ld bc,4096
	ldir
	;P-array and s-boxes are set up
	;Now we cycle repeatedly through the key and XOR it with the p-array
	ld hl,8000h
	ld de,pArray
	ld b,32
	call Blowfish_Setup_XORKey
	ld hl,8000h
	ld de,pArray+32
	ld b,32
	call Blowfish_Setup_XORKey
	ld hl,8000h
	ld de,pArray+64
	ld b,8
	call Blowfish_Setup_XORKey
	;P-array XORed and set up
	ld hl,xTemp2
	ld (hl),0
	ld de,xTemp2+1
	ld bc,7
	ldir
	;xTemp2 initialized to zeroes
	ld b,9
	ld de,pArray
	ld hl,xTemp2
Blowfish_Setup_Loop:
	push bc
	push de
	xor a
	call Blowfish_Process
	pop de
	ld h,d
	ld l,e
	inc de
	inc de
	inc de
	inc de
	inc de
	inc de
	inc de
	inc de
	pop bc
	djnz Blowfish_Setup_Loop
	;Now do s-boxes
	ld bc,512
	ld de,SBox_1
	ld hl,9944h
Blowfish_Setup_Loop2:
	push bc
	push de
	xor a
	call Blowfish_Process
	pop de
	ld h,d
	ld l,e
	inc de
	inc de
	inc de
	inc de
	inc de
	inc de
	inc de
	inc de
	pop bc
	dec bc
	ld a,b
	or c
	jr nz,Blowfish_Setup_Loop2
	ret	;all done
Blowfish_NotEnoughMemory:
	ld hl,Blowfish_NotEnoughMemory_Data
	call DisplayScreen
	jp AppStart
Blowfish_Setup_XORKey:
	ld a,(de)
	xor (hl)
	ld (de),a
	inc hl
	inc de
	djnz Blowfish_Setup_XORKey
	ret
Blowfish_Close:
	ld hl,9D95h
	ld de,106Bh
	B_CALL DelMem
	ret
Blowfish_NotEnoughMemory_Data:
	DB "Sorry,  but  you  do",1
	DB "not  have  enough  free",1
	DB "RAM  to  use  Blowfish",1
	DB "encryption.",1,1,1
	DB "Press any key",0
Blowfish_P_Array:
	DL 0243F6A88h,03707344h,082EFA98h,038D01377h,0C0AC29B7h,0B5470917h
	DL 085A308D3h,0A4093822h,0EC4E6C89h,0BE5466CFh,0C97C50DDh,09216D5D9h
	DL 013198A2Eh,0299F31D0h,0452821E6h,034E90C6Ch,03F84D5B5h,08979FB1Bh
Blowfish_S_Box1:
	;This doubles a GOST box as well
GOST_S_Box1:
	DL 0D1310BA6h,024A19947h
	DL 0D95748Fh,0C5D1B023h
GOST_S_Box2:
	DL 0D71577C1h,055CA396Ah
	DL 02BA9C55Dh,03B8F4898h
GOST_S_Box3:
	DL 098DFB5ACh,0B3916CF7h
	DL 0728EB658h,0286085F0h
GOST_S_Box4:
	DL 0BD314B27h,02AAB10B6h
	DL 0741831F6h,06B4BB9AFh
GOST_S_Box5:
	DL 02FFD72DBh,0801F2E2h
	DL 0718BCD58h,0CA417918h
GOST_S_Box6:
	DL 078AF2FDAh,0B4CC5C34h
	DL 0CE5C3E16h,0C4BFE81Bh
GOST_S_Box7:
	DL 0D01ADFB7h,0858EFC16h
	DL 082154AEEh,0B8DB38EFh
GOST_S_Box8:
	DL 055605C60h,01141E8CEh
	DL 09B87931Eh,066282193h
	DL 0B8E1AFEDh,0636920D8h,07B54A41Dh,08E79DCB0h,0E65525F3h,0A15486AFh,0AFD6BA33h,061D809CCh
	DL 06A267E96h,071574E69h,0C25A59B5h,0603A180Eh,0AA55AB94h,07C72E993h,06C24CF5Ch,0FB21A991h
	DL 0BA7C9045h,0A458FEA3h,09C30D539h,06C9E0E8Bh,057489862h,0B3EE1411h,07A325381h,0487CAC60h
	DL 0F12C7F99h,0F4933D7Eh,02AF26013h,0B01E8A3Eh,063E81440h,0636FBC2Ah,028958677h,05DEC8032h
	DL 0EF845D5Dh,02E0B4482h,06A51A0D2h,0A1F1651Dh,0E06F75D8h,037D0D724h,0E3FE501Ah,068FB6FAFh
	DL 0E98575B1h,0A4842004h,0D8542F68h,039AF0176h,085C12073h,0D00A1248h,0B6794C3Bh,03E6C53B5h
	DL 0DC262302h,069C8F04Ah,0960FA728h,066CA593Eh,0401A449Fh,0DB0FEAD3h,0976CE0BDh,01339B2EBh
	DL 0EB651B88h,09E1F9B5Eh,0AB5133A3h,082430E88h,056C16AA6h,049F1C09Bh,04C006BAh,03B52EC6Fh
	DL 023893E81h,021C66842h,06EEF0B6Ch,08CEE8619h,04ED3AA62h,075372C9h,0C1A94FB6h,06DFC511Fh
	DL 0D396ACC5h,0F6E96C9Ah,0137A3BE4h,0456F9FB4h,0363F7706h,080991B7Bh,0409F60C4h,09B30952Ch
	DL 0F6D6FF3h,0670C9C61h,0BA3BF050h,07D84A5C3h,01BFEDF72h,025D479D8h,05E5C9EC2h,0CC814544h
	DL 083F44239h,0ABD388F0h,07EFB2A98h,03B8B5EBEh,0429B023Dh,0F6E8DEF7h,0196A2463h,0AF5EBD09h
	DL 0BEE3D004h,05579C0BDh,03C7516DFh,09E5C57BBh,0695B27B0h,09A53E479h,0EF20CADAh,0D08ED1D0h
	DL 0DE334AFDh,01A60320Ah,0FD616B15h,0CA6F8CA0h,0BBCA58C8h,0B6F84565h,036774C01h,0AFC725E0h
	DL 0660F2807h,0D6A100C6h,02F501EC8h,01A87562Eh,0E1FFA35Dh,0D28E49BCh,0D07E9EFEh,08E3C5B2Fh
	DL 0192E4BB3h,0402C7279h,0AD0552ABh,0DF1769DBh,0B8F011A0h,04BFB9790h,02BF11FB4h,08E7594B7h
	DL 0C0CBA857h,0679F25FEh,0323DB5FAh,0D542A8F6h,010FA3D98h,0E1DDF2DAh,095DBDA4Dh,08FF6E2FBh
	DL 045C8740Fh,0FB1FA3CCh,0FD238760h,0287EFFC3h,0FD2183B8h,0A4CB7E33h,0AE909198h,0F2122B64h
	DL 0D20B5F39h,08EA5E9F8h,053317B48h,0AC6732C6h,04AFCB56Ch,062FB1341h,0EAAD8E71h,08888B812h
	DL 0B9D3FBDBh,0DB3222F8h,03E00DF82h,08C4F5573h,02DD1D35Bh,0CEE4C6E8h,06B93D5A0h,0900DF01Ch
	DL 04FAD5EA0h,0E5A0CC0Fh,0165FA266h,0EBCDAF0Ch,02464369Bh,083260376h,0D60F573Fh,0B6636521h
	DL 0688FC31Ch,0B56F74E8h,080957705h,07B3E89A0h,0F009B91Eh,06295CFA9h,0BC9BC6E4h,0E7B9F9B6h
	DL 0D1CFF191h,018ACF3D6h,093CC7314h,0D6411BD3h,05563911Dh,011C81968h,02B60A476h,0FF34052Eh
	DL 0B3A8C1ADh,0CE89E299h,0211A1477h,0AE1E7E49h,059DFA6AAh,04E734A41h,081E67400h,0C5855664h
	DL 02F2F2218h,0B4A84FE0h,0E6AD2065h,0250E2Dh,078C14389h,0B3472DCAh,08BA6FB5h,053B02D5Dh
	DL 0BE0E1777h,0FD13E0B7h,077B5FA86h,02071B35Eh,0D95A537Fh,07B14A94Ah,0571BE91Fh,0A99F8FA1h
	DL 0EA752DFEh,07CC43B81h,0C75442F5h,0226800BBh,0207D5BA2h,01B510052h,0F296EC6Bh,08BA4799h
	DL 08B021FA1h,0D2ADA8D9h,0FB9D35CFh,057B8E0AFh,02E5B9C5h,09A532915h,02A0DD915h,06E85076Ah
Blowfish_S_Box2:
	DL 04B7A70E9h,0ECAA8C71h,03F54989Ah,04CDD2086h,0687F3584h,0B03ADA37h,0D19113F9h,0A9446146h
	DL 0B5B32944h,0699A17FFh,05B429D65h,08470EB26h,052A0E286h,0F0500C0Dh,07CA92FF6h,0FD0030Eh
	DL 0DB75092Eh,05664526Ch,06B8FE4D6h,06382E9C6h,0B79C5305h,0F01C1F04h,094324773h,0ECC8C73Eh
	DL 0C4192623h,0C2B19EE1h,099F73FD6h,021ECC5Eh,0AA500737h,0200B3FFh,022F54701h,0A4751E41h
	DL 0AD6EA6B0h,0193602A5h,0A1D29C07h,09686B3Fh,03E07841Ch,0AE0CF51Ah,03AE5E581h,0E238CD99h
	DL 049A7DF7Dh,075094C29h,0EFE830F5h,03EBAEFC9h,07FDEAE5Ch,03CB574B2h,037C2DADCh,03BEA0E2Fh
	DL 09CEE60B8h,0A0591340h,04D2D38E6h,03C971814h,08E7D44ECh,025837A58h,0C8B57634h,03280BBA1h
	DL 08FEDB266h,0E4183A3Eh,0F0255DC1h,06B6A70A1h,05716F2B8h,0DC0921BDh,09AF3DDA7h,0183EB331h
	DL 04E548B38h,0DE9A771Fh,07A584718h,0EF1C1847h,071DFF89Eh,0F28FE6EDh,0771FE71Ch,0C6150EBAh
	DL 04F6DB908h,0D9930810h,07408DA17h,03215D908h,010314E55h,097F1FBFAh,04E3D06FAh,094E2EA78h
	DL 06F420D03h,0B38BAE12h,0BC9F9ABCh,0DD433B37h,081AC77D6h,09EBABF2Ch,02965DCB9h,0A5FC3C53h
	DL 0F60A04BFh,0DCCF3F2Eh,0E94B7D8Ch,024C2BA16h,05F11199Bh,01E153C6Eh,099E71D0Fh,01E0A2DF4h
	DL 02CB81290h,05512721Fh,0EC7AEC3Ah,012A14D43h,043556F1h,086E34570h,0803E89D6h,0F2F74EA7h
	DL 024977C79h,02E6B7124h,0DB851DFAh,02A65C451h,0D7A3C76Bh,0EAE96FB1h,05266C825h,0361D2B3Dh
	DL 05679B072h,0501ADDE6h,063094366h,050940002h,03C11183Bh,0860E5E0Ah,02E4CC978h,01939260Fh
	DL 0BCAF89AFh,09F84CD87h,0C464C3D2h,0133AE4DDh,05924A509h,05A3E2AB3h,09C10B36Ah,019C27960h
	DL 05223A708h,0C332DDEFh,01521B628h,0B5735C90h,0648B1EAFh,09B540B19h,0E358829h,0CDB30AEBh
	DL 0F71312B6h,0BE6C5AA5h,029076170h,04C70A239h,019BDF0CAh,0875FA099h,0C7E61FD6h,0532E3054h
	DL 0EBADFE6Eh,065582185h,0ECDD4775h,0D59E9E0Bh,0A02369B9h,095F7997Eh,096DEDFA1h,08FD948E4h
	DL 0EAC31F66h,068AB9802h,0619F1510h,0CBAADE14h,0655ABB50h,0623D7DA8h,07858BA99h,06DBC3128h
	DL 0E3BC4595h,0EECEA50Fh,013CCA830h,0EECC86BCh,040685A32h,0F837889Ah,057F584A5h,058EBF2EFh
	DL 0A67BC883h,0DB2F953Bh,0EB61BD96h,060622CA7h,03C2AB4B3h,097E32D77h,01B227263h,034C6FFEAh
	DL 0B17F37D1h,02AEF7DADh,0334FE1Eh,09CAB5CABh,0319EE9D5h,011ED935Fh,09B83C3FFh,0FE28ED61h
	DL 018CFF28h,05B6E2F84h,0AA0363CFh,0B2F3846Eh,0C021B8F7h,016681281h,01AC24696h,0EE7C3C73h
	DL 05D4A14D9h,0C742F442h,0CF62A1F2h,095BBF00h,03372F092h,0A6078084h,09E447A2Eh,0C5C43465h
	DL 0E864B7E3h,0EF6ABBB5h,05B8D2646h,0AD19489Dh,08D937E41h,019F8509Eh,0C3453484h,0713E38D8h
	DL 042105D14h,0654F3B1Dh,0FC8883A0h,01462B174h,0D65FECF1h,0E8EFD855h,0FDD56705h,03D28F89Eh
	DL 0203E13E0h,041CD2105h,0C1C7B6A3h,023820E00h,06C223BDBh,061D99735h,0E1E9EC9h,0F16DFF20h
	DL 045EEE2B6h,0D81E799Eh,07F1524C3h,058428D2Ah,07CDE3759h,0A969A7AAh,0DB73DBD3h,0153E21E7h
	DL 0A3AAABEAh,086854DC7h,069CB7492h,0C55F5EAh,0CBEE7460h,0C50C06C2h,0105588CDh,08FB03D4Ah
	DL 0DB6C4F15h,0E44B476Ah,047848A0Bh,01DADF43Eh,04085F2A7h,05A04ABFCh,0675FDA79h,0E6E39F2Bh
	DL 0FACB4FD0h,03D816250h,05692B285h,0233F7061h,0CE77326Eh,0800BCADCh,0E3674340h,0DB83ADF7h
Blowfish_S_Box3:
	DL 0E93D5A68h,0D4082471h,04D95FC1Dh,096EB27B3h,068DC1462h,0AACE1E7Ch,01DC9FAF7h,0FB0AF54Eh
	DL 0948140F7h,03320F46Ah,096B591AFh,055FD3941h,0D7486900h,0D3375FECh,04B6D1856h,0D8FEB397h
	DL 0F64C261Ch,043B7D4B7h,070F4DDD3h,0DA2547E6h,0680EC0A4h,0CE78A399h,026A36631h,0454056ACh
	DL 094692934h,0500061AFh,066A02F45h,0ABCA0A9Ah,027A18DEEh,0406B2A42h,0EAE397B2h,0BA489527h
	DL 0411520F7h,01E39F62Eh,0BFBC09ECh,028507825h,04F3FFEA2h,020FE9E35h,03A6EFA74h,055533A3Ah
	DL 07602D4F7h,097244546h,03BD9785h,0530429F4h,0E887AD8Ch,0D9F385B9h,0DD5B4332h,020838D87h
	DL 0BCF46B2Eh,014214F74h,07FAC6DD0h,0A2C86DAh,0B58CE006h,0EE39D7ABh,06841E7F7h,0FE6BA9B7h
	DL 0D4A20068h,0BF8B8840h,031CB8504h,0E9B66DFBh,07AF4D6B6h,03B124E8Bh,0CA7820FBh,0D096954Bh
	DL 055A867BCh,0FDF8E802h,07F9C9EEh,0257B7834h,06B2395E0h,0D0127845h,0A476341h,0C67B5510h
	DL 0A1159A58h,04272F70h,041041F0Fh,0602A9C60h,0333E92E1h,095B794FDh,0992EFF74h,06D672C37h
	DL 0CCA92963h,080BB155Ch,0404779A4h,0DFF8E8A3h,03B240B62h,0647D0862h,03A6F6EABh,02765D43Bh
	DL 099E1DB33h,05282CE3h,05D886E17h,01F636C1Bh,0EEBEB922h,0E7CCF5F0h,0F4F8FD37h,0DCD0E804h
	DL 0A62A4A56h,095C11548h,0325F51EBh,0E12B4C2h,085B2A20Eh,05449A36Fh,0A812DC60h,0F1290DC7h
	DL 03F3125F9h,0E4C66D22h,0D59BC0D1h,02E1329Eh,0E6BA0D99h,0877D48FAh,0A1EBDDF8h,0CC00FFA3h
	DL 05EF47E1Ch,048C1133Fh,0F2BCC18Fh,0AF664FD1h,0DE720C8Ch,0C39DFD27h,0991BE14Ch,0B5390F92h
	DL 09029317Ch,0C70F86DCh,041113564h,0CAD18115h,02DA2F728h,0F33E8D1Eh,0DB6E6B0Dh,0690FED0Bh
	DL 0667B9FFBh,037392EB3h,06A124237h,044421659h,09DBC8057h,083426B33h,04E58F48Fh,07AEB2661h
	DL 0CEDB7D9Ch,0CC115979h,0B79251E7h,0A121386h,0F0F7C086h,0F01EAB71h,0F2DDFDA2h,08B1DDF84h
	DL 0A091CF0Bh,08026E297h,06A1BBE6h,0D90CEC6Eh,060787BF8h,0B0804187h,0F474EF38h,0846A0E79h
	DL 0D9155EA3h,0F42E312Dh,04BFB6350h,0D5ABEA2Ah,06003604Dh,03C005E5Fh,08789BDC2h,0915F95E2h
	DL 0BB132F88h,06842ADA7h,01A6B1018h,064AF674Eh,0D1FD8346h,077A057BEh,05366F9C3h,0466E598Eh
	DL 0515BAD24h,0C66A2B3Bh,011CAEDFAh,0DA86A85Fh,0F6381FB0h,0BDE8AE24h,0C8B38E74h,020B45770h
	DL 07B9479BFh,012754CCCh,03D25BDD8h,0BEBFE988h,07745AE04h,055464299h,0B475F255h,08CD55591h
	DL 0763BD6EBh,0782EF11Ch,0E2E1C3C9h,064E4C3FEh,0D736FCCCh,0BF582E61h,046FCD9B9h,0C902DE4Ch
	DL 0B90BACE1h,0E85A1F02h,0DCB7DA83h,09AF88C27h,011E69ED7h,06F05E409h,0ED545578h,06FD5C7E7h
	DL 0BB8205D0h,09F0BE8Ch,0573906FEh,0773F8641h,02338EA63h,04B7C0188h,08FCA5B5h,056E14EC4h
	DL 011A86248h,04A99A025h,0A1E2CE9Bh,0C3604C06h,053C2DD94h,039720A3Dh,0D83D7CD3h,0362ABFCEh
	DL 07574A99Eh,01D6EFE10h,04FCD7F52h,061A806B5h,0C2C21634h,07C927C24h,04DAD0FC4h,0DDC6C837h
	DL 0B77F19B6h,01AB93D1Dh,050115E01h,0F0177A28h,0BBCBEE56h,086E3725Fh,01E50EF5Eh,0D79A3234h
	DL 0E0A9DC09h,0BA5A4DFh,0A70683FAh,0C0F586E0h,090BCB6DEh,0724D9DB9h,0B161E6F8h,092638212h
	DL 0662D09A1h,0A186F20Fh,0A002B5C4h,06058AAh,0EBFC7DA1h,01AC15BB4h,0A28514D9h,0670EFA8Eh
	DL 0C4324633h,02868F169h,0DE6D027h,030DC7D62h,0CE591D76h,0D39EB8FCh,06C51133Ch,0406000E0h
Blowfish_S_Box4:
	DL 03A39CE37h,0D5118E9Dh,05748AB2Fh,02939BBDBh,0C089C2B8h,02826A2F9h,080E4A915h,096D5AC3Ah
	DL 0D3FAF5CFh,0BF0F7315h,0BC946E79h,0A9BA4650h,043242EF6h,0A73A3AE1h,087B08601h,017DA67Dh
	DL 0ABC27737h,0D62D1C7Eh,0C6A376D2h,0AC9526E8h,0A51E03AAh,04BA99586h,09B09E6ADh,0D1CF3ED6h
	DL 05AC52D1Bh,0C700C47Bh,06549C2C8h,0BE5EE304h,09CF2D0A4h,0EF5562E9h,03B3EE593h,07C7D2D28h
	DL 05CB0679Eh,0B78C1B6Bh,0530FF8EEh,0A1FAD5F0h,083C061BAh,0C72FEFD3h,0E990FD5Ah,01F9F25CFh
	DL 04FA33742h,021A19045h,0468DDE7Dh,06A2D519Ah,09BE96A4Dh,0F752F7DAh,09E34D797h,0ADF2B89Bh
	DL 0D3822740h,0B26EB1BEh,0D5730A1Dh,063EF8CE2h,08FE51550h,03F046F69h,02CF0B7D9h,05AD6B472h
	DL 099BC9BBEh,06A366EB4h,04CD04DC6h,09A86EE22h,0BA645BD6h,077FA0A59h,022B8B51h,05A88F54Ch
	DL 0E029AC71h,0785F0191h,0C3EB9E15h,07533D928h,04DE81751h,0A8B6E37Eh,0B39A460Ah,0DDA26A7Eh
	DL 0E019A5E6h,0ED756055h,03C9057A2h,0B155FDF5h,03830DC8Eh,0C3293D46h,06445C0DDh,03A59FF45h
	DL 047B0ACFDh,0F7960E44h,097271AECh,03563482h,0379D5862h,048DE5369h,0586CDECFh,03E350A44h
	DL 0ED93FA9Bh,0E3D35E8Ch,0A93A072Ah,08ABA3CBBh,09320F991h,06413E680h,01C20C8AEh,0BCB4CDD5h
	DL 0E8D3C48Dh,015056DD4h,01B3F6D9Bh,028517711h,0EA7A90C2h,0A2AE0810h,05BBEF7DDh,072EACEA8h
	DL 0283B57CCh,088F46DBAh,01E6321F5h,0C20AD9F8h,0FB3E7BCEh,0DD6DB224h,01B588D40h,0FA6484BBh
	DL 0F8D56629h,03A16125h,0F59C66FBh,0ABCC5167h,05121CE64h,069852DFDh,0CCD2017Fh,08D6612AEh
	DL 079132E28h,0564F0BDh,026DCF319h,0CCAD925Fh,0774FBE32h,09072166h,06BB4E3BBh,0BF3C6F47h
	DL 0D29BE463h,04040CB08h,06F3F3B82h,0A08839E1h,01A908749h,0F79E59B7h,0FAE59361h,0E0EC6E0Eh
	DL 0542F5D9Eh,04EB4E2CCh,03520AB82h,051CE794Bh,0D44FBD9Ah,043F5BB3Ah,0CEB69CEBh,01698DB3Bh
	DL 0AEC2771Bh,034D2466Ah,011A1D4Bh,02F32C9B7h,0D0DADECBh,0F2D519FFh,0C2A86459h,04C98A0BEh
	DL 0F64E6370h,0115AF84h,0277227F8h,0A01FBAC9h,0D50ADA38h,027D9459Ch,012BAA8D1h,03278E964h
	DL 0740E0D8Dh,0E1B00428h,0611560B1h,0E01CC87Eh,0339C32Ah,0BF97222Ch,0B6C1075Eh,09F1F9532h
	DL 0E75B1357h,095983A1Dh,0E7933FDCh,0BCC7D1F6h,0C6913667h,015E6FC2Ah,0E3056A0Ch,0E0D392DFh
	DL 0F8721671h,06B89FB4h,0BB3A792Bh,0CF0111C3h,08DF9317Ch,0F91FC71h,010D25065h,0D3A0342Bh
	DL 0AF537D5Dh,0CE6EA048h,0344525BDh,0A1E8AAC7h,0E0B12B4Fh,09B941525h,0CB03A442h,08971F21Eh
	DL 01B0A7441h,0E54CDA54h,0F523F357h,0DE966292h,0C9AA53FDh,053113EC0h,085CBFE4Eh,090D4F869h
	DL 04BA3348Ch,01EDAD891h,0A6327623h,081B949D0h,062A80F00h,01640E3D3h,08AE88DD8h,0A65CDEA0h
	DL 0C5BE7120h,0CE6279CFh,093A83531h,04C50901Bh,0BB25BFE2h,038ABBD60h,07AAAF9B0h,03F09252Dh
	DL 0C37632D8h,0CD3E7E6Fh,056CCCD02h,071C65614h,035BDD2F6h,02547ADF0h,04CF9AA7Eh,0C208E69Fh
	DL 0DF359F8Dh,01618B166h,0ACF08162h,0E6C6C7BDh,071126905h,0BA38209Ch,01948C25Ch,0B74E6132h
	DL 09B992F2Eh,0FD2C1D05h,05A75EBB5h,0327A140Ah,0B2040222h,0F746CE76h,02FB8A8Ch,0CE77E25Bh
	DL 0E60B6F47h,0848FD2C5h,06E163697h,045E1D006h,0B6CBCF7Ch,077AFA1C5h,01C36AE4h,0578FDFE3h
	DL 0FE3F11Dh,0F6FB2299h,088D273CCh,0C3F27B9Ah,0CD769C2Bh,020756060h,0D6EBE1F9h,03AC372E6h
