Decrypt_SecondStep:
;	B_CALL GrBufClr
;	B_CALL ClrLCDFull
;	ld de,50*256
;	ld (pencol),de
;	ld hl,Decrypt_Password_Prompt
;	call vputstr
;	ld de,57*256
;	ld (pencol),de
;	call vputstr
;	call GetPassword_Secure
;	ld hl,enteredpass
;	ld de,thepass
;	ld bc,8
;	ldir
;	B_CALL ClrLCDFull
;	ld de,0
;	ld (pencol),de
;	ld hl,Decrypt_Password_ConfirmPrompt
;	call vputstr
;	call GetPassword_Secure
;	ld hl,thepass
;	ld de,enteredpass
;	ld b,8
;	call CompareStrings
;	jr z,Decrypt_SecondStep_Good
;	B_CALL ClrLCDFull
;	ld hl,Encrypt_ThirdStep_UserIsLoser
;	ld de,0
;	ld (pencol),de
;	call vputstr
;	ld de,57*256
;	ld (pencol),de
;	call vputstr
;	call GetPassword_Secure
Decrypt_SecondStep_Good:
	;ld hl,enteredpass
	ld hl,blahblahblah
	ld de,cbcbytes
	ld bc,8
	ldir
Decrypt_SecondStep_2:
	;Look up which algorithm
	ld hl,(curpointer)
	ld de,-5
	add hl,de
	ld a,(hl)
	or a
	jr z,Decrypt_SecondStep_RAM
	;It's archived!
	;HL is at page byte
	inc hl
	ld d,(hl)
	inc hl
	ld e,(hl)
	push hl
	ex de,hl
	ld bc,64
	ld de,8000h
	B_CALL FlashToRam
	ld hl,8009h
	ld e,(hl)
	ld d,0
	inc e
	add hl,de
	;HL points to size bytes of data
	jr Decrypt_SecondStep_Go
Decrypt_SecondStep_RAM:
	inc hl
	ld d,(hl)
	inc hl
	ld e,(hl)
	ex de,hl
Decrypt_SecondStep_Go:
	ld de,12
	add hl,de
	ld a,(hl)
	;A is the type code
	;Mask out bit 7
	res 7,a
	;Now jump to appropriate code
	or a
	jr z,Decrypt_Go_RC6
	dec a
	jp z,Decrypt_Go_Blowfish
	dec a
	jp z,Decrypt_Go_GOST
	;Put other algorithms here as needed
	INCLUDE "dodecrypt.asm"
Menu_Decrypt:
	B_CALL GrBufClr
	B_CALL ClrLCDFull
	ld bc,7
	ld de,95*256+7
	B_CALL DarkLine
	ld bc,40*256
	ld de,40*256+63
	B_CALL DarkLine
	ld hl,Menu_Encrypt_Step1_Text
	ld de,57*256+1
	ld (pencol),de
	call vputstr
	call VAT_GetFirstEncrypted
	or a
	jp z,Menu_Encrypt_NoPrograms
	;We found at least one
	;HL points to its entry
	ld (toppointer),hl
	ld (curpointer),hl
	xor a
	ld (curpos),a
	call Menu_Decrypt_DisplayScreen
	call Highlight_Current
	call Menu_Decrypt_ShowInfo
	;Now execute loop
Menu_Decrypt_Loop:
	ei
	halt
	B_CALL GetCSC
	cp skClear
	jp z,AppStart
	cp skDown
	jr z,Menu_Decrypt_Down
	cp skUp
	jr z,Menu_Decrypt_Up
	cp sk2nd
	jp z,Decrypt_SecondStep
	cp skEnter
	jp z,Decrypt_SecondStep
	jr Menu_Decrypt_Loop
Menu_Decrypt_Up:
	ld a,(curpos)
	or a
	jr z,Menu_Decrypt_UpFetch
	call Highlight_Current
	ld hl,curpos
	dec (hl)
	call Highlight_Current
	ld hl,(progPtr)
Menu_Decrypt_Up_Loop:
	ld (oldpointer),hl
Menu_Decrypt_Up_Loop2:
	call VAT_GetNext2
	ld de,(curpointer)
	or a
	sbc hl,de
	jr z,Menu_Decrypt_Up_Found
	jr c,Menu_Decrypt_Up_Found
	add hl,de
	ld (oldpointer),hl
	call NextVATEntry
	jr Menu_Decrypt_Up_Loop2
Menu_Decrypt_Up_Found:
	ld hl,(oldpointer)
	ld (curpointer),hl
	call Menu_Decrypt_ShowInfo
	jr Menu_Decrypt_Loop
Menu_Decrypt_UpFetch:
	res foundOne,(iy+progSearch)
	ld hl,(progPtr)
Menu_Decrypt_UpFetch_Loop:
	ld (oldpointer),hl
Menu_Decrypt_UpFetch_Loop2:
	call VAT_GetNext2
	or a
	jr z,Menu_Decrypt_Loop
	ld de,(curpointer)
	or a
	sbc hl,de
	jr z,Menu_Decrypt_UpFetch_Found
	jr c,Menu_Decrypt_UpFetch_Found
	add hl,de
	ld (oldpointer),hl
	call NextVATEntry
	set foundOne,(iy+progSearch)
	jr Menu_Decrypt_UpFetch_Loop2
Menu_Decrypt_UpFetch_Found:
	bit foundOne,(iy+progSearch)
	jr z,Menu_Decrypt_Loop
	ld hl,(oldpointer)
	ld (toppointer),hl
	ld (curpointer),hl
	ld hl,0
	ld de,55*256+36
	B_CALL ClearRect
	call Menu_Decrypt_DisplayScreen
	call Highlight_Current
	call Menu_Decrypt_ShowInfo
	jr Menu_Decrypt_Loop
Menu_Decrypt_Down:
	ld a,(curpos)
	cp 7
	jr z,Menu_Decrypt_DownFetch
	call Highlight_Current
	ld hl,curpos
	inc (hl)
	call Highlight_Current
	ld hl,(curpointer)
	call NextVATEntry
	call VAT_GetNext2
	or a
	jr z,Menu_Decrypt_Down_No
	ld (curpointer),hl
	call Menu_Decrypt_ShowInfo
	jr Menu_Decrypt_Loop
Menu_Decrypt_DownFetch:
	ld hl,(curpointer)
	call NextVATEntry
	call VAT_GetNext2
	or a
	jr z,Menu_Decrypt_Loop
	ld (curpointer),hl
	ld hl,0
	ld de,55*256+36
	B_CALL ClearRect
	ld hl,(toppointer)
	call NextVATEntry
	call VAT_GetNext2
	ld (toppointer),hl
	call Menu_Decrypt_DisplayScreen
	call Highlight_Current
	call Menu_Decrypt_ShowInfo
	jr Menu_Decrypt_Loop
Menu_Decrypt_Down_No:
	call Highlight_Current
	ld hl,curpos
	dec (hl)
	call Highlight_Current
	jr Menu_Decrypt_Loop
Menu_Decrypt_DisplayScreen:
	;Displays a screen of up to 8 programs
	ld hl,2
	ld (pencol),hl
	ld hl,(toppointer)
	call DisplayProgram
	ld hl,(toppointer)
	ld b,7
Menu_Decrypt_DisplayScreen_Loop:
	push bc
	call NextVATEntry
	call VAT_GetNext2
	or a
	jr z,Menu_Decrypt_DisplayScreen_Exit
	;HL points to next program
	push hl
	ld a,2
	ld (pencol),a
	ld a,(penrow)
	add a,7
	ld (penrow),a
	call DisplayProgram
	pop hl
	pop bc
	djnz Menu_Decrypt_DisplayScreen_Loop
	ret
Menu_Decrypt_DisplayScreen_Exit:
	pop bc
	ret
Menu_Decrypt_ShowInfo:
	ld de,2*256+43
	ld (pencol),de
	ld hl,(curpointer)
	ld de,-5
	add hl,de
	ld a,(hl)
	or a
	jr z,Menu_Decrypt_ShowInfo_RAM
	;It's archived!
	;HL is at page byte
	inc hl
	ld d,(hl)
	inc hl
	ld e,(hl)
	;push hl
	ex de,hl
	ld bc,64
	ld de,8000h
	B_CALL FlashToRam
	ld hl,8009h
	ld e,(hl)
	ld d,0
	inc e
	add hl,de
	;HL points to size bytes of data
	jr Menu_Decrypt_ShowInfo_Go
Menu_Decrypt_ShowInfo_RAM:
	inc hl
	ld d,(hl)
	inc hl
	ld e,(hl)
	ex de,hl
Menu_Decrypt_ShowInfo_Go:
	ld de,12
	add hl,de
	ld a,(hl)
	;A is the type code
	;Mask out bit 7
	res 7,a
	;Now find type
	ld hl,Encryption_Type_Table
	call GetString
	jp vputstr
GetString:
	;Inputs - HL points to table
	;A is string to get
	;Returns HL points to string
	or a
	ret z
	ld b,a
GetString_Loop:
	push bc
	ld bc,-1
	xor a
	cpir
	pop bc
	djnz GetString_Loop
	ret
Encryption_Type_Table:
	DB "RC6  (256-bit)",6,6,6,6,0
	DB "Blowfish",6,6,6,6,0
	DB "GOST",6,6,6,6,0
Decrypt_Password_Prompt:
	DB "Enter  the  password  for",0
	DB "this  file.",0
Decrypt_Password_ConfirmPrompt:
	DB "Confirm  password:",0
