Encrypt_Go_GOST:
	B_CALL ClrLCDFull
	ld hl,0
	ld (pencol),hl
	ld hl,Encrypt_Go_GOST_Status
	call vputstr
	call GOST_Setup
	;Now do the encryption
	call Encrypt_Go_MoveToRAM
	;Our variable to encrypt is in RAM now
	call Encrypt_Go_SizeCheck
	ld a,c
	push bc
	and 7
	ld e,a
	ld a,8
	sub e
	and 7
	add a,13
	;A now is the number of bytes to insert
	ex de,hl
	inc de
	ld h,0
	ld l,a
	B_CALL InsertMem
	ld hl,Checksum_Encrypted
	ld bc,10
	ldir
	ld a,2		;Set encryption as GOST
	ld hl,(curpointer)
	bit 1,(hl)
	jr z,Encrypt_Go_GOST_5
	set 7,a
Encrypt_Go_GOST_5:
	ld (de),a
	ex de,hl
	inc hl
	pop bc
	ld (hl),c
	inc hl
	ld (hl),b
	;Now we need to update the size field
	ld a,c
	and 7
	ld e,a
	ld a,8
	sub e
	and 7
	add a,13
	ld h,0
	ld l,a
	add hl,bc
	;HL is updated size
	ld b,h
	ld c,l
	ld hl,(curpointer)
	ld (hl),6
	dec hl
	dec hl
	dec hl
	ld e,(hl)
	dec hl
	ld d,(hl)
	ex de,hl
	ld (hl),c
	inc hl
	ld (hl),b
	;Now for the actual encryption
	;13 bytes before padding
	ld de,14
	add hl,de
	push hl
	ld h,b
	ld l,c
	ld de,13
	or a
	sbc hl,de
	;HL is the length of bytes to encrypt
	srl h
	rr l
	srl h
	rr l
	srl h
	rr l
	;HL \ 8
	ld b,h
	ld c,l
	pop hl
	;HL is start, BC number of times
	ld (total),bc
	ld ix,0
	ld (status),ix
	push bc
	push hl
	ld de,5*256+2
	ld (currow),de
	ld a,' '
	B_CALL PutC
	ld a,'/'
	B_CALL PutC
	ld hl,(total)
	B_CALL DispHL
	pop hl
	pop bc
	di
Encrypt_Go_GOST_Loop:
	push bc
	push hl
	ld b,8
	ld de,cbcbytes
Encrypt_Go_GOST_Loop_CBC:
	ld a,(de)
	xor (hl)
	ld (hl),a
	inc hl
	inc de
	djnz Encrypt_Go_GOST_Loop_CBC
	pop hl
	push hl
	call GOST_Encrypt
	pop hl
	push de
	ld de,cbcbytes
	ld bc,8
	ldir
	;Update status
	ld hl,(status)
	inc hl
	ld (status),hl
	bit 3,l
	jp z,Encrypt_Go_GOST_Loop_NoShowStatus
	ld de,2
	ld (currow),de
	B_CALL DispHL
Encrypt_Go_GOST_Loop_NoShowStatus:
	pop hl
	pop bc
	dec bc
	ld a,b
	or c
	jp nz,Encrypt_Go_GOST_Loop
	ei
	jp AppStart
Encrypt_Go_GOST_Status:
	DB "Encrypting (GOST)...",0
Encrypt_Go_Blowfish_SetupStatus:
	DB "Initializing  subkeys...",0
Encrypt_Go_Blowfish:
	B_CALL GrBufClr
	B_CALL ClrLCDFull
	ld hl,0
	ld (pencol),hl
	ld hl,Encrypt_Go_Blowfish_SetupStatus
	call vputstr
	call Blowfish_Setup
	B_CALL ClrLCDFull
	ld hl,0
	ld (pencol),hl
	ld hl,Encrypt_Go_Blowfish_Status
	call vputstr
	;Now do the encryption
	call Encrypt_Go_MoveToRAM
	;Our variable to encrypt is in RAM now
	call Encrypt_Go_SizeCheck
	ld a,c
	push bc
	and 7
	ld e,a
	ld a,8
	sub e
	and 7
	add a,13
	;A now is the number of bytes to insert
	ex de,hl
	inc de
	ld h,0
	ld l,a
	B_CALL InsertMem
	ld hl,Checksum_Encrypted
	ld bc,10
	ldir
	ld a,1		;Set encryption as Blowfish
	ld hl,(curpointer)
	bit 1,(hl)
	jr z,Encrypt_Go_Blowfish_5
	set 7,a
Encrypt_Go_Blowfish_5:
	ld (de),a
	ex de,hl
	inc hl
	pop bc
	ld (hl),c
	inc hl
	ld (hl),b
	;Now we need to update the size field
	ld a,c
	and 7
	ld e,a
	ld a,8
	sub e
	and 7
	add a,13
	ld h,0
	ld l,a
	add hl,bc
	;HL is updated size
	ld b,h
	ld c,l
	ld hl,(curpointer)
	ld (hl),6
	dec hl
	dec hl
	dec hl
	ld e,(hl)
	dec hl
	ld d,(hl)
	ex de,hl
	ld (hl),c
	inc hl
	ld (hl),b
	;Now for the actual encryption
	;13 bytes before padding
	ld de,14
	add hl,de
	push hl
	ld h,b
	ld l,c
	ld de,13
	or a
	sbc hl,de
	;HL is the length of bytes to encrypt
	srl h
	rr l
	srl h
	rr l
	srl h
	rr l
	;HL \ 8
	ld b,h
	ld c,l
	pop hl
	;HL is start, BC number of times
	ld d,h
	ld e,l
	ld (total),bc
	ld ix,0
	ld (status),ix
	push bc
	push de
	push hl
	ld de,5*256+2
	ld (currow),de
	ld a,' '
	B_CALL PutC
	ld a,'/'
	B_CALL PutC
	ld hl,(total)
	B_CALL DispHL
	pop hl
	pop de
	pop bc
Encrypt_Go_Blowfish_Loop:
	push bc
	push de
	push hl
	ld b,8
	ld de,cbcbytes
Encrypt_Go_Blowfish_Loop_CBC:
	ld a,(de)
	xor (hl)
	ld (hl),a
	inc hl
	inc de
	djnz Encrypt_Go_Blowfish_Loop_CBC
	pop hl
	pop de
	push de
	push hl
	xor a
	call Blowfish_Process
	pop hl
	ld de,cbcbytes
	ld bc,8
	ldir
	;Update status
	ld hl,(status)
	inc hl
	ld (status),hl
	bit 3,l
	jp z,Encrypt_Go_Blowfish_Loop_NoShowStatus
	ld de,2
	ld (currow),de
	B_CALL DispHL
Encrypt_Go_Blowfish_Loop_NoShowStatus:
	pop de
	ex de,hl
	ld bc,8
	add hl,bc
	ld d,h
	ld e,l
	pop bc
	dec bc
	ld a,b
	or c
	jp nz,Encrypt_Go_Blowfish_Loop
	call Blowfish_Close
	jp AppStart
Encrypt_Go_Blowfish_Status:
	DB "Encrypting (Blowfish)...",0
Encrypt_Go_RC6:
	B_CALL GrBufClr
	B_CALL ClrLCDFull
	ld hl,0
	ld (pencol),hl
	ld hl,Encrypt_Go_RC6_Status
	call vputstr
	;Now we can load the key
	ld hl,KeyFile
	rst 20h
	B_CALL ChkFindSym
	jr c,Encrypt_Go_RC6_KeyNotFound
	ld a,b
	or a
	jr z,Encrypt_Go_RC6_KeyLoad
	;Key appvar is archived...Stream to flash
	;A is ROM page
	ex de,hl
	ld de,20
	add hl,de
	bit 7,h
	jr z,Encrypt_Go_RC6_ArchivedGo
	res 7,h
	set 6,h
	inc a
Encrypt_Go_RC6_ArchivedGo:
	;HL, A are set
	ld de,8000h
	ld bc,32
	B_CALL FlashToRam
	jr Encrypt_Go_RC6_KeyDecode
Encrypt_Go_RC6_KeyLoad:
	ex de,hl
	inc hl
	inc hl
	ld de,8000h
	ld bc,32
	ldir
	;Key now copied to RAM at 8000h
Encrypt_Go_RC6_KeyDecode:
	ld hl,8000h
	call GenerateKeySchedule
	;User key now ready for encrypt. Let's go.
	call Encrypt_Go_MoveToRAM
	call Encrypt_Go_SizeCheck
	ld a,c
	push bc
	and 3
	ld e,a
	ld a,4
	sub e
	and 3
	add a,13
	;A now is the number of bytes to insert
	ex de,hl
	inc de
	ld h,0
	ld l,a
	B_CALL InsertMem
	ld hl,Checksum_Encrypted
	ld bc,10
	ldir
	xor a
	ld hl,(curpointer)
	bit 1,(hl)
	jr z,Encrypt_Go_RC6_5
	set 7,a
Encrypt_Go_RC6_5:
	ld (de),a
	ex de,hl
	inc hl
	pop bc
	ld (hl),c
	inc hl
	ld (hl),b
	;Now we need to update the size field
	ld a,c
	and 3
	ld e,a
	ld a,4
	sub e
	and 3
	add a,13
	ld h,0
	ld l,a
	add hl,bc
	;HL is updated size
	ld b,h
	ld c,l
	ld hl,(curpointer)
	ld (hl),6
	dec hl
	dec hl
	dec hl
	ld e,(hl)
	dec hl
	ld d,(hl)
	ex de,hl
	ld (hl),c
	inc hl
	ld (hl),b
	;Now for the actual encryption
	;13 bytes before padding
	ld de,14
	add hl,de
	push hl
	ld h,b
	ld l,c
	ld de,13
	or a
	sbc hl,de
	;HL is the length of bytes to encrypt
	srl h
	rr l
	srl h
	rr l
	;HL \ 4
	ld b,h
	ld c,l
	pop hl
	;HL is start, BC number of times
	ld (total),bc
	ld ix,0
	ld (status),ix
	push bc
	push hl
	ld de,5*256+2
	ld (currow),de
	ld a,' '
	B_CALL PutC
	ld a,'/'
	B_CALL PutC
	ld hl,(total)
	B_CALL DispHL
	pop hl
	pop bc
Encrypt_Go_RC6_Loop:
	push bc
	call RC6_Encrypt
	push de
	;Update status
	ld hl,(status)
	inc hl
	ld (status),hl
	bit 3,l
	jp z,Encrypt_Go_RC6_Loop_NoShowStatus
	ld de,2
	ld (currow),de
	B_CALL DispHL
Encrypt_Go_RC6_Loop_NoShowStatus:
	pop hl
	pop bc
	dec bc
	ld a,b
	or c
	jp nz,Encrypt_Go_RC6_Loop
	jp AppStart
Encrypt_Go_RC6_KeyNotFound:
	ld hl,Encrypt_Go_RC6_KeyNotFound_Data
	call DisplayScreen
	jp AppStart
Encrypt_Go_RC6_KeyNotFound_Data:
	DB "The key appvar could",1
	DB "not be found.",1,1,1,1,1
	DB "Press any key",0
Encrypt_Go_RC6_Status:
	DB "Encrypting (256-bit RC6)...",0
DecryptUserKey:
Encrypt_Go_RC6_DecodeUserKey:
	;Now the key is at 8000h...Decrypt the user's key by using the master key
	ld hl,8000h
	ld b,8
Encrypt_Go_RC6_DecodeUserKey_Loop:
	push bc
	call RC6_Decrypt
	ex de,hl
	pop bc
	djnz Encrypt_Go_RC6_DecodeUserKey_Loop
	ret
Encrypt_Go_MoveToRAM:
	ld hl,(curpointer)
	ld de,-5
	add hl,de
	ld a,(hl)
	or a
	ret z
	push hl
	B_CALL ZeroOP1
	pop hl
	ld de,5
	add hl,de
	ld a,(hl)
	ld (OP1),a
	ld de,-6
	add hl,de
	ld b,(hl)
	dec hl
	ld de,OP1+1
Encrypt_Go_RC6_OP1Load:
	ld a,(hl)
	ld (de),a
	dec hl
	inc de
	djnz Encrypt_Go_RC6_OP1Load
	B_CALL Arc_Unarc
	ret
Encrypt_Go_SizeCheck:
	ld hl,(curpointer)
	dec hl
	dec hl
	dec hl
	ld e,(hl)
	dec hl
	ld d,(hl)
	ex de,hl
	ld c,(hl)
	inc hl
	ld b,(hl)
	;HL on upper byte of size bytes
	ld a,b
	or c
	jp z,Encrypt_Go_ZeroLengthError
	ret
