Encrypt_SecondStep:
	;This is where the user selects which encryption algorithm to use
	B_CALL GrBufClr
	B_CALL ClrLCDFull
	ld hl,Encrypt_SecondStep_Title
	ld de,0
	ld (pencol),de
	call vputstr
	ld de,57*256
	ld (pencol),de
	call vputstr
	;Now display list of algorithms
	ld hl,14*256+6
	ld (pencol),hl
	ld hl,Encrypt_SecondStep_List
	call vputstr
	ld de,21*256+6
	ld (pencol),de
	call vputstr
	ld de,28*256+6
	ld (pencol),de
	call vputstr
	;Now display cursor
	ld de,14*256+1
	ld (pencol),de
	ld a,5
	B_CALL VPutMap
	xor a
	ld (curmenu),a
Encrypt_SecondStep_Loop:
	ei
	halt
	B_CALL GetCSC
	cp skClear
	jp z,AppStart
	cp skDown
	jr z,Encrypt_SecondStep_OptionDown
	cp skUp
	jr z,Encrypt_SecondStep_OptionUp
	cp skEnter
	jp z,Encrypt_SecondStep_OptionPicked
	cp sk2nd
	jp z,Encrypt_SecondStep_OptionPicked
	jr Encrypt_SecondStep_Loop
Encrypt_SecondStep_OptionUp:
	ld a,(curmenu)
	or a
	jr z,Encrypt_SecondStep_Loop
	call Encrypt_SecondStep_EraseCursor
	ld hl,curmenu
	dec (hl)
	call Encrypt_SecondStep_DrawCursor
	jr Encrypt_SecondStep_Loop
Encrypt_SecondStep_OptionDown:
	ld a,(curmenu)
	cp 2
	jr z,Encrypt_SecondStep_Loop
	call Encrypt_SecondStep_EraseCursor
	ld hl,curmenu
	inc (hl)
	call Encrypt_SecondStep_DrawCursor
	jr Encrypt_SecondStep_Loop
Encrypt_SecondStep_DrawCursor:
	ld a,(curmenu)
	ld b,a
	add a,a
	add a,a
	add a,a
	sub b
	add a,14
	ld (penrow),a
	xor a
	ld (pencol),a
	ld a,5
	B_CALL VPutMap
	ret
Encrypt_SecondStep_EraseCursor:
	ld a,(curmenu)
	ld b,a
	add a,a
	add a,a
	add a,a
	sub b
	add a,14
	ld (penrow),a
	xor a
	ld (pencol),a
	ld a,6
	B_CALL VPutMap
	ret
Encrypt_SecondStep_List
	DB "Blowfish  (256-bit)",0
	DB "GOST  (256-bit)",0
	DB "RC6  (256-bit)",0
Encrypt_SecondStep_Title:
	DB "Select  an  algorithm:",0
	DB "Step 2:  Pick  an  algorithm",0
	INCLUDE "doencrypt.asm"
Encrypt_SecondStep_OptionPicked:
;	B_CALL GrBufClr
;	B_CALL ClrLCDFull
;Encrypt_SecondStep_Screen:
;	ld hl,57*256
;	ld (pencol),hl
;	ld hl,Encrypt_ThirdStep_Title
;	call vputstr
;	ld de,0
;	ld (pencol),de
;	call GetPassword_Secure
	;First password now in (enteredpass)
;	ld hl,enteredpass
;	ld de,thepass
;	ld bc,8
;	ldir
;	B_CALL GrBufClr
;	B_CALL ClrLCDFull
;	ld hl,57*256
;	ld (pencol),hl
;	ld hl,Encrypt_ThirdStep_Title
;	call vputstr
;	ld hl,Encrypt_ThirdStep_Confirm
;	ld de,0*256
;	ld (pencol),de
;	call vputstr
;	call GetPassword_Secure
;	ld hl,enteredpass
;	ld de,thepass
;	ld b,8
;	call CompareStrings
;	jr z,Encrypt_Third_Step_Matches
	;The user mistyped his password
;	B_CALL ClrLCDFull
;	ld hl,Encrypt_ThirdStep_UserIsLoser
;	ld de,0
;	ld (pencol),de
;	call vputstr
;	ld de,57*256
;	ld (pencol),de
;	call vputstr
;	jr Encrypt_SecondStep_Screen
Encrypt_Third_Step_Matches:
	;Stick the password in the initialization for the CBC
	;ld hl,thepass
	ld hl,blahblahblah
	ld de,cbcbytes
	ld bc,8
	ldir
Encrypt_ThirdStep_Ready:
	ld a,(curmenu)
	or a
	jp z,Encrypt_Go_Blowfish
	dec a
	jp z,Encrypt_Go_GOST
	dec a
	jp z,Encrypt_Go_RC6
;Encrypt_ThirdStep_Title:
;	DB "Step 3:  Enter  a  password",0
;	DB "Type  a  password:",0
;Encrypt_ThirdStep_Confirm:
;	DB "Confirm  the  password:",0
;Encrypt_ThirdStep_UserIsLoser:
;	DB "Passwords  don't  match",0
;	DB "Enter  it  again,  carefully",0
Menu_Encrypt:
	B_CALL GrBufClr
	B_CALL ClrLCDFull
	ld bc,7
	ld de,95*256+7
	B_CALL DarkLine
	ld bc,40*256
	ld de,40*256+63
	B_CALL DarkLine
	ld hl,Menu_Encrypt_Step1_Text
	ld de,57*256+1
	ld (pencol),de
	call vputstr
	call VAT_GetFirstNormal
	or a
	jr z,Menu_Encrypt_NoPrograms
	;We found at least one
	;HL points to its entry
	ld (toppointer),hl
	ld (curpointer),hl
	xor a
	ld (curpos),a
	call Menu_Encrypt_DisplayScreen
	call Highlight_Current
	;Now execute loop
Menu_Encrypt_Loop:
	ei
	halt
	B_CALL GetCSC
	cp skClear
	jp z,AppStart
	cp skDown
	jr z,Menu_Encrypt_Down
	cp skUp
	jr z,Menu_Encrypt_Up
	cp sk2nd
	jp z,Encrypt_SecondStep
	cp skEnter
	jp z,Encrypt_SecondStep
	jr Menu_Encrypt_Loop
Menu_Encrypt_Up:
	ld a,(curpos)
	or a
	jr z,Menu_Encrypt_UpFetch
	call Highlight_Current
	ld hl,curpos
	dec (hl)
	call Highlight_Current
	ld hl,(progPtr)
Menu_Encrypt_Up_Loop:
	ld (oldpointer),hl
Menu_Encrypt_Up_Loop2:
	call VAT_GetNext
	ld de,(curpointer)
	or a
	sbc hl,de
	jr z,Menu_Encrypt_Up_Found
	jr c,Menu_Encrypt_Up_Found
	add hl,de
	ld (oldpointer),hl
	call NextVATEntry
	jr Menu_Encrypt_Up_Loop2
Menu_Encrypt_Up_Found:
	ld hl,(oldpointer)
	ld (curpointer),hl
	jr Menu_Encrypt_Loop
Menu_Encrypt_UpFetch:
	res foundOne,(iy+progSearch)
	ld hl,(progPtr)
Menu_Encrypt_UpFetch_Loop:
	ld (oldpointer),hl
Menu_Encrypt_UpFetch_Loop2:
	call VAT_GetNext
	or a
	jr z,Menu_Encrypt_Loop
	ld de,(curpointer)
	or a
	sbc hl,de
	jr z,Menu_Encrypt_UpFetch_Found
	jr c,Menu_Encrypt_UpFetch_Found
	add hl,de
	ld (oldpointer),hl
	call NextVATEntry
	set foundOne,(iy+progSearch)
	jr Menu_Encrypt_UpFetch_Loop2
Menu_Encrypt_UpFetch_Found:
	bit foundOne,(iy+progSearch)
	jr z,Menu_Encrypt_Loop
	ld hl,(oldpointer)
	ld (toppointer),hl
	ld (curpointer),hl
	ld hl,0
	ld de,55*256+36
	B_CALL ClearRect
	call Menu_Encrypt_DisplayScreen
	call Highlight_Current
	jr Menu_Encrypt_Loop
Menu_Encrypt_Down:
	ld a,(curpos)
	cp 7
	jr z,Menu_Encrypt_DownFetch
	call Highlight_Current
	ld hl,curpos
	inc (hl)
	call Highlight_Current
	ld hl,(curpointer)
	call NextVATEntry
	call VAT_GetNext
	or a
	jr z,Menu_Encrypt_Down_No
	ld (curpointer),hl
	jr Menu_Encrypt_Loop
Menu_Encrypt_DownFetch:
	ld hl,(curpointer)
	call NextVATEntry
	call VAT_GetNext
	or a
	jr z,Menu_Encrypt_Loop
	ld (curpointer),hl
	ld hl,0
	ld de,55*256+36
	B_CALL ClearRect
	ld hl,(toppointer)
	call NextVATEntry
	call VAT_GetNext
	ld (toppointer),hl
	call Menu_Encrypt_DisplayScreen
	call Highlight_Current
	jr Menu_Encrypt_Loop
Menu_Encrypt_Down_No:
	call Highlight_Current
	ld hl,curpos
	dec (hl)
	call Highlight_Current
	jr Menu_Encrypt_Loop
Menu_Encrypt_DisplayScreen:
	;Displays a screen of up to 8 programs
	ld hl,2
	ld (pencol),hl
	ld hl,(toppointer)
	call DisplayProgram
	ld hl,(toppointer)
	ld b,7
Menu_Encrypt_DisplayScreen_Loop:
	push bc
	call NextVATEntry
	call VAT_GetNext
	or a
	jr z,Menu_Encrypt_DisplayScreen_Exit
	;HL points to next program
	push hl
	ld a,2
	ld (pencol),a
	ld a,(penrow)
	add a,7
	ld (penrow),a
	call DisplayProgram
	pop hl
	pop bc
	djnz Menu_Encrypt_DisplayScreen_Loop
	ret
Menu_Encrypt_DisplayScreen_Exit:
	pop bc
	ret
DisplayProgram:
	;Input - HL points to VAT entry
	ld de,-6
	add hl,de
	ld b,(hl)
	dec hl
DisplayProgram_Loop:
	push bc
	ld a,(hl)
	B_CALL VPutMap
	dec hl
	pop bc
	djnz DisplayProgram_Loop
	ret
Highlight_Current:
	ld a,(curpos)
	ld b,a
	add a,a
	add a,a
	add a,a
	sub b
	;A = row to start
	ld h,a
	ld l,0
	add a,6
	ld d,a
	ld e,35
	B_CALL InvertRect
	ret
Menu_Encrypt_NoPrograms:
	ld hl,Menu_Encrypt_NoPrograms_Data
	call DisplayScreen
	jp AppStart
Menu_Encrypt_NoPrograms_Data:
	DB "No usable programs were",1
	DB "found.",1,1,1,1,1,1,1,1
	DB "Press any key",0
Checksum_Encrypted:
	;Length of checksum - 10 bytes
	DB 0D5h,3Fh,"Krolypto"
Menu_Encrypt_Step1_Text:
	DB "Step 1:  Select  a  file",0
Encrypt_Go_ZeroLengthError:
	ld hl,Encrypt_Go_ZeroLengthError_Data
	call DisplayScreen
	jp AppStart
Encrypt_Go_ZeroLengthError_Data:
	DB "You cannot encrypt a",1
	DB "program which has no data.",1,1,1,1,1,1,1
	DB "Press any key",0
