Getcsc_Hook:
	add a,e
	res GetcscHook,(iy+Hooks1)
	ld hl,Menu_About_Data
	ld de,progToEdit
	ld bc,8
	ldir
	ld hl,StartupCode_Checksum
	ld de,appbackupscreen
	ld bc,7
	ldir
	B_CALL CloseEditEqu
	B_CALL PutAway
	B_CALL ReloadAppEntryVecs
	B_CALL ExecuteApp
	xor a
	ret
StartupProtection:
	;Begin lockdown
	ld hl,StartupVectors
	B_CALL AppInit
	set 7,(iy+28h)
	ld a,(iy+34h)
	push af
	ld a,(iy+35h)
	push af
	ld a,(iy+36h)
	push af
	ld a,(iy+shiftflags)
	push af
	xor a
	ld (iy+34h),a
	ld (iy+35h),a
	ld (iy+36h),a
	ld (iy+shiftflags),a
	res battery,(iy+lockdown)
StartupProtection_NoNoNo:
	res 4,(iy+24h)
	res textWrite,(iy+sGrFlags)
	B_CALL ClrScrnFull
	ld hl,50*256
	ld (pencol),hl
	ld hl,Startup_Message
	call vputstr
	ld de,57*256
	ld (pencol),de
	call vputstr
	ld hl,0
	ld (currow),hl
	B_CALL CursorOff
	B_CALL CursorOn
	bit battery,(iy+lockdown)
	jr z,StartupProtection_SkipPowerDown
	B_CALL EnableApd
	ld hl,0101h
	ld (apdSubTimer),hl
	res battery,(iy+lockdown)
StartupProtection_SkipPowerDown:
	res monabandon,(iy+monFlags)
	ld hl,enteredpass
	ld (hl),0
	ld de,enteredpass+1
	ld bc,7
	ldir
	ld ix,enteredpass
	xor a
	ld (enteredpasslen),a
StartupProtection_GetPasswordLoop:
	res onInterrupt,(iy+onFlags)
	push ix
	set 7,(iy+28h)
	B_CALL GetKey
	res onInterrupt,(iy+onFlags)
	pop ix
	res apdRunning,(iy+apdFlags)
	cp kEnter
	jr nz,StartupProtection_NotEnter
	ld a,(enteredpasslen)
	or a
	jr z,StartupProtection_GetPasswordLoop
	jr StartupProtection_PasswordDone
StartupProtection_NotEnter:
	ld (ix),a
	inc ix
	ld a,'*'
	B_CALL PutC
	ld a,(enteredpasslen)
	inc a
	ld (enteredpasslen),a
	cp 8
	jr nz,StartupProtection_GetPasswordLoop
StartupProtection_PasswordDone:
	in a,(4)
	bit 3,a
	jr z,StartupProtection_PasswordDone
	call LoadRealPassword
	ld hl,md5checksum
	ld de,md5checksum2
	ld bc,16
	ldir
	ld hl,enteredpass
	call MD5
	ld hl,md5checksum
	ld de,md5checksum2
	ld b,16
	call CompareStrings
	set battery,(iy+lockdown)
	jp nz,StartupProtection_NoNoNo
	;Password successful
	pop af
	ld (iy+shiftflags),a
	pop af
	ld (iy+36h),a
	pop af
	ld (iy+35h),a
	pop af
	ld (iy+34h),a
	B_CALL ReloadAppEntryVecs
	B_CALL CursorOff
	res 7,(iy+28h)
	;One last check...if we overwrote the Omnicalc _getcsc hook, we must apologize.
	call GetRealSettings
	jr c,StartupProtection_Finished
	bit 0,(hl)
	jr z,StartupProtection_Finished
	ld hl,Omnicalc_App
	rst 20h
	B_CALL FindApp
	jr c,StartupProtection_Finished
	ld hl,Omnicalc_Code
	ld de,ramCode+2
	ld bc,Omnicalc_Code_End-Omnicalc_Code
	ldir
	call ramCode+2
StartupProtection_Finished:
	B_JUMP JForceCmdNoChar
Omnicalc_Code:
	ld b,a
	in a,(6)
	push af
	ld a,b
	out (6),a
	ld a,(400Fh)
	daa
	jr nc,Omnicalc_Code_1
	ld hl,(4089h+1)
	inc hl
	ld a,b
	B_CALL SetGetcscHook
Omnicalc_Code_1:
	pop af
	out (6),a
	ret
Omnicalc_Code_End:
Omnicalc_Appvar:
	DB AppVarObj,"Omnicalc"
GetRealSettings:
	ld hl,Omnicalc_Appvar
	rst 20h
	B_CALL ChkFindSym
	ld a,b
	ret c
	or a
	jr nz,GetRealSettings_Archived
	ex de,hl
	inc hl
	inc hl
	or a
	ret
GetRealSettings_Archived:
	ex de,hl
	ld bc,20
	add hl,bc
	bit 7,h
	jr z,$F
	res 7,h
	set 6,h
$$:
	ld de,tempSwapArea
	push de
	ld bc,14
	B_CALL FlashToRam
	pop hl
	or a
	ret
Omnicalc_App:
	DB AppObj,"Omnicalc"
Startup_Message:
	DB "A password is required",0
	DB "for operation.",0
StartupVectors:
	DW DummyReturn
	DW DummyReturn
	DW StopPutAway
	DW DummyReturn
	DW DummyReturn
	DW DummyReturn
	DB appTextSaveF
StopPutAway:
	set battery,(iy+lockdown)
	res plotLoc,(iy+plotFlags)
	res textWrite,(iy+sGrFlags)
	ld (iy+textFlags),0
	B_CALL SetTblGraphDraw
	bit monabandon,(iy+monFlags)
	jr nz,StopPutAway_TurningOff
	ld a,iall
	out (intrptEnPort),a
	B_CALL LCD_DRIVERON
	set onRunning,(iy+onFlags)
	ei
StopPutAway_TurningOff:
	B_CALL EnableApd
	ld hl,0101h
	ld (apdSubTimer),hl
	jp StartupProtection_NoNoNo
Hook:
	add a,e
	cp 36h		;check for memory menu
	jr z,Hook_Memory
	cp 2Ch		;check for APPS menu
	jr z,Hook_Apps
	cp 0ACh		;check for Alpha+S menu
	jr z,Hook_S
	cp kPrgm		;check for program menu
	jr z,Hook_Program
	ld hl,Omnicalc_Keys
	ld c,(hl)
	inc hl
	ld b,0
	cpir
	jp z,Hook_Omnicalc
	cp k1
	jr c,Hook_Safe_Exit
	cp k9
	jr nc,Hook_Safe_Exit
	jp Hook_Omnicalc
Hook_Safe_Exit:
	or a
	ret
Omnicalc_Keys:
	DB 17
	DB k3,k5,kLog,kMath
	DB kVars,0Dh,k0,kDel
	DB 0ACh
	DB kCapO,kCapP,kCapT,kCapU,kCapV,kCapY,kCapZ,kTheta
Hook_Program:
	in a,(4)
	bit 3,a
	jr nz,Hook_Program_Exit
	;Find the appvar
	call Hook_FindAppVar
	inc de
	inc de
	ld a,(de)
	bit 3,a
	jr z,Hook_Program_Exit
	;Toggle programs between hidden and non-hidden
	xor 16
	ld (de),a
	and 00010000b
	srl a
	srl a
	srl a
	ld c,a
	;C is 0 if we are to hide, 1 to unhide
	;Search the VAT for programs!
	ld hl,(progPtr)
Hook_Program_VATnext:
	ld de,(pTemp)
	or a
	sbc hl,de
	jr z,Hook_Program_Exit
	jr c,Hook_Program_Exit
	add hl,de
	ld a,(hl)
	sub 6
	jr z,Hook_Program_Check
	inc a
	jr z,Hook_Program_Check
	ld de,-6
	add hl,de
	ld d,0
	ld e,(hl)
	inc e
	or a
	sbc hl,de
	jr Hook_Program_VATnext
Hook_Program_Check:
	;We found a program
	ld de,-7
	add hl,de
	;HL is on the first byte of the name
	ld a,40h
	cp (hl)
	jr nc,Hook_Program_Hidden
	;The program is visible
	ld a,c
	or a
	jr nz,Hook_Program_No
	ld a,(hl)
	sub 40h
	ld (hl),a
	jr Hook_Program_No
Hook_Program_Hidden:
	ld a,c
	or a
	jr z,Hook_Program_No
	push hl
	ld de,PasswordFile+1
	ld b,8
	call ReverseCompare
	pop hl
	jr z,Hook_Program_No
	push hl
	ld de,PasswordFile+10
	ld b,8
	call ReverseCompare
	pop hl
	jr z,Hook_Program_No
	ld a,(hl)
	cp '!'
	jr z,Hook_Program_No
	cp '#'
	jr z,Hook_Program_No
	add a,40h
	ld (hl),a
Hook_Program_No:
	inc hl
	ld e,(hl)
	inc e
	ld d,0
	or a
	sbc hl,de
	jr Hook_Program_VATnext
Hook_Program_Exit:
	ld a,kPrgm
	or a
	jp Hook_Omnicalc
ReverseCompare:
	ld a,(de)
	cp (hl)
	ret nz
	dec hl
	inc de
	djnz ReverseCompare
	ret
Hook_S:
	ld a,(cxCurApp)
	cp cxMode
	jr nz,Hook_S_Exit
	push af
	call Hook_FindAppVar
	pop af
	jr c,Hook_Destroy
	inc de
	inc de
	ld a,(de)
	bit 1,a
	jr z,Hook_S_Exit
	ld hl,savesscreen
	B_CALL SaveDisp
	call Hook_Secure
	jr z,Hook_S_Exit
	call Hook_Restore
	xor a
	ret
Hook_S_Exit:
	ld a,0ACh
	or a
	jp Hook_Omnicalc
Hook_Apps:
	push af
	call Hook_FindAppVar
	pop af
	jr c,Hook_Destroy
	inc de
	inc de
	ld a,(de)
	bit 0,a
	jr z,Hook_Apps_Exit
	ld hl,savesscreen
	B_CALL SaveDisp
	call Hook_Secure
	jr z,Hook_Apps_Exit
	call Hook_Restore
	xor a
	ret
Hook_Apps_Exit:
	ld a,2Ch
	or a
	jp Hook_Omnicalc
Hook_Restore:
	ld hl,savesscreen
	ld b,64
	B_CALL RestoreDisp
	ret
Hook_Memory:
	push af
	call Hook_FindAppVar
	pop af
	jr c,Hook_Destroy
	inc de
	inc de
	ld a,(de)
	bit 1,a
	jr z,Hook_Memory_Exit
	;We need to protect this!
	ld hl,savesscreen
	B_CALL SaveDisp
	call Hook_Secure
	jr z,Hook_Memory_Exit
	;It didn't match
	call Hook_Restore
	xor a
	ret	
Hook_Memory_Exit:
	ld a,36h
	or a
	jp Hook_Omnicalc
Hook_Destroy:
	res GetKeyHook,(iy+Hooks1)
	or a
	ret
Hook_FindAppVar:
	ld hl,Password_AppVar
	rst 20h
	B_CALL ChkFindSym
	ret
Hook_Secure:
	B_CALL GrBufClr
	B_CALL ClrLCDFull
	ld hl,50*256
	ld (pencol),hl
	ld hl,Hook_Secure_Text
	call vputstr
	ld de,57*256
	ld (pencol),de
	call vputstr
	call GetPassword
	res 7,(iy+28h)
	call LoadRealPassword
	ld hl,md5checksum
	ld de,md5checksum2
	ld bc,16
	ldir
	ld hl,enteredpass
	call MD5
	ld hl,md5checksum
	ld de,md5checksum2
	ld b,16
	call CompareStrings
	res shift2nd,(iy+shiftflags)
	ret
Hook_Secure_Text:
	DB "This calculator requires",0
	DB "a password to continue.",0
Hook_Omnicalc:
	ld hl,(ramcode)
	ld (appbackupscreen),hl
	push af
	call GetRealSettings
	jr c,Hook_Omnicalc_Sorry
	bit 0,(hl)
	jr z,Hook_Omnicalc_Sorry
	ld hl,Omnicalc_App
	rst 20h
	B_CALL FindApp
	jr c,Hook_Omnicalc_Sorry
	ld hl,Hook_Omnicalc_Loader
	ld de,ramCode+2
	ld bc,Hook_Omnicalc_Loader_End-Hook_Omnicalc_Loader
	ldir
	call ramCode+2
Hook_Omnicalc_Sorry:
	pop af
	ret
Hook_Omnicalc_Loader:
	ld b,a
	in a,(6)
	push af
	ld a,b
	out (6),a
	ld a,(400Fh)
	daa
	jr nc,Hook_Omnicalc_Loader_No
	pop af
	pop hl
	pop af
	ld hl,(4086h+1)
	inc hl
	ld bc,(appbackupscreen)
	ld (ramcode),bc
	jp (hl)
Hook_Omnicalc_Loader_No:
	pop af
	out (6),a
	ret
Hook_Omnicalc_Loader_End:
