Menu_Key:
	ld hl,KeyFile
	rst 20h
	B_CALL ChkFindSym
	jr nc,Menu_Key_Exists
	;We need to create key
	ld hl,Menu_Key_Create_Data
	call DisplayScreen
	;Now get key input
	B_CALL ClrScrnFull
	ld hl,0
	ld (currow),hl
	B_CALL CursorOn
	xor a
	ld (keyinputlen),a
	ld ix,keyinput
KeyInput_Loop:
	B_CALL GetCSC
	or a
	jr z,KeyInput_Loop
	cp skEnter
	jr z,KeyInput_Enter
	cp skDel
	jr z,KeyInput_Backspace
	cp skClear
	jp z,AppStart
	ld hl,KeyInput_Chart
	ld bc,16
	cpir
	jr nz,KeyInput_Loop
	ld a,(keyinputlen)
	cp 64
	jr z,KeyInput_Loop
	;Key is valid
	ld bc,15
	add hl,bc
	;HL points to raw byte
	ld a,(hl)
	ld (ix),a
	inc ix
	;Now update length
	ld a,(keyinputlen)
	inc a
	ld (keyinputlen),a
	;Now display
	add hl,bc
	inc hl
	ld a,(hl)
	B_CALL PutC
	jr KeyInput_Loop
KeyInput_Backspace:
	ld a,(keyinputlen)
	or a
	jr z,KeyInput_Loop
	dec a
	ld (keyinputlen),a
	dec ix
	B_CALL CursorOff
	ld a,(curcol)
	or a
	jr z,KeyInput_Backspace_Row
	dec a
	ld (curcol),a
	ld a,' '
	B_CALL PutMap
	B_CALL CursorOn
	jr KeyInput_Loop
KeyInput_Backspace_Row:
	ld a,15
	ld (curcol),a
	ld hl,currow
	dec (hl)
	ld a,' '
	B_CALL PutMap
	B_CALL CursorOn
	jr KeyInput_Loop
KeyInput_Enter:
	ld a,(keyinputlen)
	cp 64
	jr nz,KeyInput_Loop
	B_CALL CursorOff
	;Now parse input and store in 8000h temporarily
	ld b,32
	ld hl,keyinput
	ld de,8000h
Menu_Key_Parse_Loop:
	ld a,(hl)
	rlca
	rlca
	rlca
	rlca
	inc hl
	ld c,(hl)
	or c
	ld (de),a
	inc de
	inc hl
	djnz Menu_Key_Parse_Loop
	;Key parsed. 32 bytes starting at 8000h. Now create appvar and store
	ld hl,KeyFile
	rst 20h
	ld hl,32
	B_CALL CreateAppVar
	inc de
	inc de
	ld hl,8000h
	ld bc,32
	ldir
	;Key created successfully.
	ld hl,Menu_Key_Yay
	call DisplayScreen
	jp AppStart
Menu_Key_Exists:
	ld hl,Menu_Key_Exists_Data
	call DisplayScreen
	jp AppStart
Menu_Key_Exists_Data:
	DB "An encryption key already",1
	DB "exists on this calculator.",1
	DB "Thus, you have no need to",1
	DB "create a new key.",1,1,1,1,1
	DB "Press any key",0
Menu_Key_Create_Data:
	DB "To use encryption, you first",1
	DB "must create a key. Use the",1
	DB "keygen.exe program that",1
	DB "came with this application",1
	DB "on your PC, for the code to",1
	DB "type in the next screen.",1,1,1
	DB "Press any key",0
Menu_Key_Yay:
	DB "Congratulations! Your key",1
	DB "was created successfully.",1
	DB "The Encrypt/Decrypt",1
	DB "features of Krolypto will",1
	DB "now operate.",1
	DB 1,1
	DB "Press any key",0
