; Krolypto v1.3
; An encryption suite for the TI-83 Plus
;
;
; (C) 2003-2004, Michael Vincent. All rights reserved.
 NOLIST
 INCLUDE "..\ti83plus.inc"
 INCLUDE "..\michael.inc"
 LIST
P8 EQU 0B7h
Q8 EQU 09Eh
vI EQU savesscreen	;byte
;vA EQU savesscreen+1	;byte
;vB EQU savesscreen+2	;byte
;vC EQU savesscreen+3	;byte
;vD EQU savesscreen+4	;byte
vJ EQU savesscreen+5	;byte
vS EQU savesscreen+6	;byte
vT EQU savesscreen+7	;byte
vU EQU savesscreen+8	;byte
curmenu EQU savesscreen+9	;byte
keyinput EQU savesscreen+10	;64 bytes
keyinputlen EQU savesscreen+74	;byte
cbcbytes EQU savesscreen+75		;8 bytes
cbccode EQU savesscreen+83			;8 bytes

;MD5 equates
paddedmessage EQU appbackupscreen ;64 bytes
;wordA EQU paddedmessage+64		;32-bit word, 4 bytes
;wordB EQU wordA+4					;32-bit word, 4 bytes
;wordC EQU wordB+4					;32-bit word, 4 bytes
;wordD EQU wordC+4					;32-bit word, 4 bytes
;wordAA EQU wordD+4		;32-bit word, 4 bytes
;wordBB EQU wordAA+4		;32-bit word, 4 bytes
;wordCC EQU wordBB+4		;32-bit word, 4 bytes
;wordDD EQU wordCC+4		;32-bit word, 4 bytes
;wordtemp EQU wordDD+4	;32-bit word, 4 bytes
;wordtemp2 EQU wordtemp+4	;32-bit word, 4 bytes
;inputA EQU wordtemp2+4	;word
;inputB EQU inputA+2	;word
;inputC EQU inputB+2	;word
;inputD EQU inputC+2	;word
;iK EQU inputD+2				;byte
;iS EQU iK+1					;byte
;iI EQU iS+1					;byte
md5checksum EQU paddedmessage+64		;16 bytes - MD5 checksum
md5checksum2 EQU md5checksum+16			;16 bytes

;9872h-98FFh is free to use
rkeys EQU 9900h	;44 bytes
key EQU rkeys+44		;32 bytes

;Blowfish equates
pArray EQU 9900h	;18*4, 72 bytes
xL EQU 9872h
xR EQU xL+4
xTemp1 EQU xR+4
xTemp2 EQU xTemp1+4
lInit EQU xTemp2+4
lEnd EQU lInit+1
lChange EQU lEnd+1
SBox_1 EQU 9E00h
SBox_2 EQU 0A200h
SBox_3 EQU 0A600h
SBox_4 EQU 0AA00h

;GOST equates
kArray EQU 9900h		;8 keys, each 4 bytes...32 bytes total
R1 EQU kArray+32		;4 bytes
R2 EQU R1+4				;4 bytes
RTemp EQU R2+4			;4 bytes


;VAT searching equates
curpointer EQU key+32	;word
toppointer EQU curpointer+2	;word
curpos EQU toppointer+2		;byte
oldpointer EQU curpos+1		;word
status EQU oldpointer+2		;word
total EQU status+2			;word

;Flag equates
progSearch EQU asm_Flag1
foundOne EQU 0
protected EQU 1
lockdown EQU asm_Flag2
battery EQU 0

;Password equates
enteredpasslen EQU 8000h	;byte
enteredpass EQU 8001h		;string
thepass EQU 8010h				;string
 INCLUDE "header.inc"
AppGo:
	ld hl,9872h
	ld de,StartupCode_Checksum
	ld b,7
	call CompareStrings
	jr nz,AppGo2
	;Match
	ld hl,0
	ld de,appbackupscreen
	ld bc,7
	ldir
	jp StartupProtection
AppGo2:
	B_CALL DisableApd
	ld hl,PasswordFile
	rst 20h
	B_CALL ChkFindSym
	jr c,AppGo_NoPasswordExists
	;There is a password.
	B_CALL GrBufClr
	B_CALL ClrLCDFull
	ld hl,0
	ld (pencol),hl
	ld hl,AppGo_Password_Welcome
	call vputstr
	;Now get the real password
	call LoadRealPassword
	;md5checksum is the password checksum
	ld hl,md5checksum
	ld de,md5checksum2
	ld bc,16
	ldir
	call GetPassword
	ld hl,enteredpass
	call MD5
	ld hl,md5checksum
	ld de,md5checksum2
	ld b,16
	call CompareStrings
	jp nz,App_Exit2
	jp AppPreStart
AppGo_Password_Welcome:
	DB "Enter  your  password:",0
AppGo_NoPasswordExists:
	im 1
	ld a,(iy+34h)
	push af
	ld a,(iy+35h)
	push af
	ld a,(iy+36h)
	push af
	xor a
	ld (iy+34h),a
	ld (iy+35h),a
	ld (iy+36h),a
	;Now create password
	B_CALL GrBufClr
	B_CALL ClrLCDFull
	ld hl,AppGo_NoPassword_Text
	call DisplayScreen
	;Now let them enter a password
	B_CALL GrBufClr
	B_CALL ClrLCDFull
	ld hl,0
	ld (pencol),hl
	ld hl,App_CreatingPassword_Title
	call vputstr
	ld hl,enteredpasslen
	ld (hl),0
	ld de,enteredpasslen+1
	ld bc,60h
	ldir
	call GetPassword
	;First password now in (enteredpass)
	ld hl,enteredpass
	ld de,thepass
	ld bc,8
	ldir
	B_CALL GrBufClr
	B_CALL ClrLCDFull
	ld hl,0
	ld (pencol),hl
	ld hl,App_CreatingPassword_ConfirmTitle
	call vputstr
	call GetPassword
	;We have a confirmation password. Make sure they match, otherwise display
	;a message and exit
	ld hl,enteredpass
	ld de,thepass
	ld b,8
	call CompareStrings
	jr nz,App_CreatingPassword_ByeBye
Krolypto_GeneratePassword:
	;Passwords are good...Create the appvar
	ld hl,PasswordFile
	rst 20h
	ld hl,16
	B_CALL CreateProg
	inc de
	inc de
	push de
	ld hl,thepass
	call MD5
	pop de
	ld hl,md5checksum
	ld bc,16
	ldir
	;Now done...archive it
	ld hl,PasswordFile
	rst 20h
	B_CALL Arc_Unarc
	jr AppStart
App_CreatingPassword_ByeBye:
	ld hl,App_CreatingPassword_NoGood
	call DisplayScreen
	jp App_Exit
App_CreatingPassword_NoGood:
	DB "Your  passwords  did  not",1
	DB "match.  Run  Krolypto",1
	DB "again  and  try  again.",1,1,1,1,1,1
	DB "Press  any  key",0
App_CreatingPassword_Title:
	DB "Enter  a  password:",0
App_CreatingPassword_ConfirmTitle:
	DB "Verify  the  password:",0
GetPassword:
	;Creates the GUI and stores the password in (enteredpass),
	;with the length in (enteredpasslen)
	xor a
	ld (enteredpasslen),a
	ld hl,enteredpass
	push hl
	ld (hl),0
	ld de,enteredpass+1
	ld bc,7
	ldir
GetPassword_Loop:
	set 7,(iy+28h)
	res onInterrupt,(iy+onFlags)
	B_CALL GetKey
	pop hl
	cp kEnter
	jr nz,GetPassword_KeyNotEnter
	ld a,(enteredpasslen)
	or a
	ret nz
	push hl
	jr GetPassword_Loop
GetPassword_KeyNotEnter:
	ld (hl),a
	inc hl
	ld a,(enteredpasslen)
	inc a
	ld (enteredpasslen),a
	cp 8
	ret z
	push hl
	;Display icon now
	ld hl,GetPassword_Image
	ld de,8050h
	ld bc,8
	ldir
	ld a,(enteredpasslen)
	dec a
	add a,a
	add a,a
	add a,a
	ld e,a
	ld d,8
	ld hl,8050h
	B_CALL DisplayImage
	jr GetPassword_Loop
GetPassword_Image:
	DB 6,8
	DB 01111000b
	DB 11101100b
	DB 11110100b
	DB 11111100b
	DB 11111100b
	DB 01111000b
AppPreStart:
 	;Security items
	im 1
	ld a,(iy+34h)
	push af
	ld a,(iy+35h)
	push af
	ld a,(iy+36h)
	push af
	xor a
	ld (iy+34h),a
	ld (iy+35h),a
	ld (iy+36h),a
	;Start of application
AppStart:
	B_CALL CursorOff
	B_CALL ClrLCDFull
	B_CALL GrBufClr
	ld hl,Splash_Sprite
	ld de,9872h
	ld bc,258
	ldir
	ld de,0
	ld hl,9872h
	B_CALL DisplayImage
	;Now put menus
	ld hl,Splash_Menus
	ld de,3*256+45
	ld (pencol),de
	call vputstr
	ld de,13*256+45
	ld (pencol),de
	call vputstr
	ld de,23*256+45
	ld (pencol),de
	call vputstr
	ld de,33*256+45
	ld (pencol),de
	call vputstr
	ld de,43*256+45
	ld (pencol),de
	call vputstr
	ld de,53*256+45
	ld (pencol),de
	call vputstr
	xor a
	ld (curmenu),a
	call Splash_ShowPointer
Splash_Loop:
	ei
	halt
	B_CALL GetCSC
	cp skDown
	jr z,Splash_Down
	cp skUp
	jr z,Splash_Up
	cp sk2nd
	jr z,Splash_Enter
	cp skEnter
	jr z,Splash_Enter
	cp skClear
	jr z,App_Exit
	cp skStore
	call z,Splash_Lockdown
	jr Splash_Loop
Splash_Enter:
	ld a,(curmenu)
	or a
	jp z,Menu_Encrypt
	dec a
	jp z,Menu_Decrypt
	dec a
	jp z,Menu_Key
	dec a
	jp z,Menu_Password
	dec a
	jp z,Menu_About
App_Exit:
	call WipeSaferam
	pop af
	ld (iy+36h),a
	pop af
	ld (iy+35h),a
	pop af
	ld (iy+34h),a
App_Exit2:
	set graphDraw,(iy+graphFlags)
	B_CALL EnableApd
	B_JUMP JForceCmdNoChar
Splash_Up:
	call Splash_HidePointer
	ld a,(curmenu)
	dec a
	ld (curmenu),a
	inc a
	jr nz,Splash_Up_Go
	ld a,5
	ld (curmenu),a
Splash_Up_Go:
	call Splash_ShowPointer
	jr Splash_Loop
Splash_Down:
	call Splash_HidePointer
	ld a,(curmenu)
	inc a
	ld (curmenu),a
	cp 6
	jr c,Splash_Down_Go
	xor a
	ld (curmenu),a
Splash_Down_Go:
	call Splash_ShowPointer
	jr Splash_Loop
Splash_HidePointer:
	ld hl,Splash_Menus_Data
	ld a,(curmenu)
	ld b,0
	ld c,a
	add hl,bc
	ld h,(hl)
	ld l,40
	ld (pencol),hl
	ld a,6
	B_CALL VPutMap
	ret
Splash_ShowPointer:
	ld hl,Splash_Menus_Data
	ld a,(curmenu)
	ld b,0
	ld c,a
	add hl,bc
	ld h,(hl)
	ld l,40
	ld (pencol),hl
	ld a,5
	B_CALL VPutMap
	ret
Splash_Menus_Data:
	DB 3,13,23,33,43,53
Splash_Menus:
	DB "Encrypt",0
	DB "Decrypt",0
	DB "Create Key",0
	DB "Password",0
	DB "About",0
	DB "Exit",0
Splash_Sprite:
	DB 64,32
	DB 255,224,0,0
	DB 187,224,30,0
	DB 219,224,33,0
	DB 199,224,76,128
	DB 215,224,82,128
	DB 219,224,94,224
	DB 189,224,210,176
	DB 255,225,0,176
	DB 231,227,255,208
	DB 219,226,0,80
	DB 195,226,0,80
	DB 215,226,0,80
	DB 155,226,0,80
	DB 221,226,0,96
	DB 255,227,255,192
	DB 255,224,0,0
	DB 227,224,0,0
	DB 221,224,0,0
	DB 221,224,0,0
	DB 221,224,0,0
	DB 221,224,0,0
	DB 227,224,0,0
	DB 255,224,0,0
	DB 255,224,0,0
	DB 223,224,30,0
	DB 223,224,33,0
	DB 223,224,76,128
	DB 223,224,82,128
	DB 222,224,94,224
	DB 225,224,210,176
	DB 255,225,0,176
	DB 255,227,255,208
	DB 221,226,0,80
	DB 221,226,0,80
	DB 221,226,0,80
	DB 235,226,0,80
	DB 247,226,0,96
	DB 239,227,255,192
	DB 223,224,0,0
	DB 191,224,0,0
	DB 241,224,0,0
	DB 238,224,0,0
	DB 238,224,0,0
	DB 225,224,0,0
	DB 239,224,0,0
	DB 239,224,0,0
	DB 239,224,0,0
	DB 223,224,0,0
	DB 255,224,0,0
	DB 255,160,30,0
	DB 192,96,33,0
	DB 187,224,76,128
	DB 251,224,82,128
	DB 251,224,94,224
	DB 251,224,210,176
	DB 231,225,0,176
	DB 255,227,255,208
	DB 255,226,0,80
	DB 227,226,0,80
	DB 221,226,0,80
	DB 221,226,0,80
	DB 221,226,0,96
	DB 227,227,255,192
	DB 255,224,0,0
blahblahblah:
	DB 9Dh,0Bh,04h,05h,0C9h,28h
	DB 19h,86h		;blah blah blah
 INCLUDE "encrypt.asm"
 INCLUDE "decrypt.asm"
Menu_About:
	B_CALL ClrLCDFull
	ld hl,Menu_About_Data
	call DisplayScreen
	jp AppStart
menu_about_temp:
	DB "Michael",7
Menu_About_Data:
	DB "Krolypto  is  copyright",1
	DB "(C)  2003,  by  Michael",1
	DB "Vincent.  Portions  of  this",1
	DB "program  contain  patented",1
	DB "and/or  copyrighted",1
	DB "material  by  others.",1
	DB 1,1
	DB "Press any key",6,6,6,6,"v1.4",0
 INCLUDE "password.asm"
 INCLUDE "key.asm"
 INCLUDE "vat.asm"
 INCLUDE "md5.asm"
KeyFile:
	DB AppVarObj,"krolypto"
NextVATEntry:
	ld de,-6
	add hl,de
	ld d,0
	ld e,(hl)
	inc e
	or a
	sbc hl,de
	ret
DisplayScreen:
	push af
	push de
	push ix
	push hl
	B_CALL ClrLCDFull
	pop hl
	ld de,0
	ld (pencol),de
DisplayScreen10:
	ld a,(hl)
	inc hl
	or a
	jr z,DisplayScreen20
	cp 1
	jr z,DisplayScreen_NewLine
	B_CALL VPutMap
	jr nc,DisplayScreen10
DisplayScreen20:
	ei
	halt
	B_CALL GetCSC
	or a
	jr z,DisplayScreen20
	pop ix
	pop de
	pop af
	ret
DisplayScreen_NewLine:
	xor a
	ld (pencol),a
	ld a,(penrow)
	add a,7
	ld (penrow),a
	jr DisplayScreen10
WipeSaferam:
	ld b,10
WipeSaferam_Loop:
	push bc
	ld hl,9872h
	ld (hl),0
	ld de,9872h+1
	ld bc,767
	ldir
	ld hl,86ECh
	ld (hl),0
	ld de,86ECh+1
	ld bc,767
	ldir
	ld hl,8000h
	ld (hl),0
	ld de,8000h+1
	ld bc,255
	ldir
	ld hl,9872h
	ld (hl),0FFh
	ld de,9872h+1
	ld bc,767
	ldir
	ld hl,86ECh
	ld (hl),0FFh
	ld de,86ECh+1
	ld bc,767
	ldir
	ld hl,8000h
	ld (hl),0FFh
	ld de,8000h+1
	ld bc,255
	ldir
	pop bc
	djnz WipeSaferam_Loop
	ret
CompareStrings:
	;Inputs - HL, DE strings, B length
	;Output - Z match, NZ not match
	ld a,(de)
	cp (hl)
	ret nz
	inc hl
	inc de
	djnz CompareStrings
	ret
DummyReturn:
	ret
	DB 03Eh
PasswordFile:
	DB 5," calcdb2"
	DB 5,"  calcdb"
AppGo_NoPassword_Text:
	DB "To use Krolypto, you must",1
	DB "create a password. On the",1
	DB "following screen, you will",1
	DB "enter a password. If you",1
	DB "forget it ever, you will",1
	DB "have to reset all memory.",1,1
	DB "Press any key",0
 INCLUDE "rc6.asm"
 INCLUDE "blowfish.asm"
 INCLUDE "gost.asm"
AppPutAway:
	set battery,(iy+lockdown)
	res plotLoc,(iy+plotFlags)
	res textWrite,(iy+sGrFlags)
	;B_CALL ReloadAppEntryVecs
	ld (iy+textFlags),0
	B_CALL SetTblGraphDraw
	bit monabandon,(iy+monFlags)
	jr nz,AppPutAway_TurningOff
	ld a,iall
	out (intrptEnPort),a
	B_CALL LCD_DRIVERON
	set onRunning,(iy+onFlags)
	ei
	;B_JUMP JForceCmdNoChar
	jp Lockdown_NoNoNo
AppPutAway_TurningOff:
	jp Lockdown_NoNoNo
	;B_JUMP PutAway
LoadRealPassword:
	ld hl,PasswordFile
	rst 20h
	B_CALL ChkFindSym
	ld a,b
	or a
	jp z,App_Exit
	ld hl,20
	add hl,de
	bit 7,h
	jr z,AppGo_Password_GetGood
	inc a
	res 7,h
	set 6,h
AppGo_Password_GetGood:
	ld de,md5checksum
	ld bc,16
	B_CALL FlashToRam
 INCLUDE "lockdown.asm"
