;Appvar
;Bit 0 - Apps
;Bit 1 - Memory
;Bit 2 - Startup
;Bit 3 - Programs
;Bit 4 - Program hiding active (for internal use only)
Menu_Password_HooksCheck:
	ld hl,(R1+1)
	ld a,(hl)
	bit 2,a
	push af
	call z,Menu_Password_Hooks_Startup_Remove
	call nz,Menu_Password_Hooks_Startup
	pop af
	and 00001011b
	jp z,AppStart
	in a,(6)
	ld hl,Hook
	B_CALL SetGetKeyHook
	res GetKeyHook,(iy+Hooks1)
	ld hl,5
	add hl,sp
	set GetKeyHook,(hl)
	jp AppStart
Menu_Password_Hooks_Startup_Remove:
	ld hl,Startup_AppVar
	rst 20h
	B_CALL ChkFindSym
	jr c,Menu_Password_Hooks_Startup_Remove_Exit
	B_CALL DelVarArc
Menu_Password_Hooks_Startup_Remove_Exit:
	xor a
	ret
Menu_Password_Hooks_Startup:
	ld hl,Startup_AppVar
	rst 20h
	B_CALL ChkFindSym
	jr c,Menu_Password_Hooks_Startup_Good
	B_CALL DelVarArc
Menu_Password_Hooks_Startup_Good:
	ld hl,StartupCode_End-StartupCode+1
	B_CALL CreateAppVar
	inc de
	inc de
	ld hl,StartupCode
	ld bc,StartupCode_End-StartupCode+1
	ldir
	set 1,(iy+33h)
	ret
StartupCode:
	ld hl,StartupCode_Krolypto-StartupCode+8001h
	rst 20h
	B_CALL FindApp
	ret c
	ld hl,Getcsc_Hook
	B_CALL SetGetcscHook
	ret
StartupCode_Krolypto:
	DB AppObj,"Krolypto"
StartupCode_End:
StartupCode_Checksum:
	DB "Michael"
Startup_AppVar:
	DB AppVarObj,"OFFSCRPT",0
Menu_Password:
	;Appvar initialization
	ld hl,Password_AppVar
	rst 20h
	B_CALL ChkFindSym
	jr nc,Menu_Password_AppVar_Exists
	ld hl,1
	B_CALL CreateAppVar
	xor a
	inc de
	inc de
	ld (de),a
Menu_Password_AppVar_Exists:
	B_CALL GrBufClr
	B_CALL ClrLCDFull
	;Now the options are displayed
	;Now draw boxes
	ld hl,Password_AppVar
	rst 20h
	B_CALL ChkFindSym
	ld a,b
	or a
	jr z,Menu_Password_NotArchived
	B_CALL Arc_Unarc
Menu_Password_NotArchived:
	ex de,hl
	inc hl
	inc hl
	ld (R1+1),hl
	ld c,(hl)
Menu_Password_DrawBoxes:
	;C contains the byte of the appvar...
	;Draw 3 boxes based on the lower 3 bits
	ld hl,28*256+6
	call Menu_Password_BoxOnC
	ld hl,36*256+6
	call Menu_Password_BoxOnC
	ld hl,44*256+6
	call Menu_Password_BoxOnC
	ld hl,52*256+6
	call Menu_Password_BoxOnC
	ld hl,Menu_Password_Options
	ld de,0*256+6
	ld (pencol),de
	call vputstr
	ld de,20*256+0
	ld (pencol),de
	call vputstr
	ld de,27*256+16
	ld (pencol),de
	call vputstr
	ld de,35*256+16
	ld (pencol),de
	call vputstr
	ld de,43*256+16
	ld (pencol),de
	call vputstr
	ld de,51*256+16
	ld (pencol),de
	call vputstr
	xor a
	ld (R1),a		;current menu
	ld a,6
	ld (R2),a		;pointer status
	call Menu_Password_TogglePointer
Menu_Password_Loop:
	ei
	halt
	B_CALL GetCSC
	cp skClear
	jr z,Menu_Password_HooksCheck
	cp skDown
	jr z,Menu_Password_MoveDown
	cp skUp
	jr z,Menu_Password_MoveUp
	cp sk2nd
	jr z,Menu_Password_Selected
	cp skEnter
	jr nz,Menu_Password_Loop
Menu_Password_Selected:
	ld a,(R1)
	or a
	jp z,Menu_Password_Change
	dec a
	jr z,Menu_Password_ToggleApps
	dec a
	jr z,Menu_Password_ToggleMemory
	dec a
	jr z,Menu_Password_ToggleStartup
	;dec a
	;jr z,Menu_Password_TogglePrograms
	;There's only one choice left
Menu_Password_TogglePrograms:
	ld hl,(R1+1)
	ld a,8
	xor (hl)
	ld (hl),a
	ld c,a
	srl c
	srl c
	srl c
	ld hl,52*256+6
	call Menu_Password_BoxOnC
	call Menu_Password_TogglePointer
	call Menu_Password_TogglePointer
	jr Menu_Password_Loop
Menu_Password_ToggleApps:
	ld hl,(R1+1)
	ld a,1
	xor (hl)
	ld (hl),a
	ld c,a
	ld hl,28*256+6
	call Menu_Password_BoxOnC
	call Menu_Password_TogglePointer
	call Menu_Password_TogglePointer
	jr Menu_Password_Loop
Menu_Password_ToggleMemory:
	ld hl,(R1+1)
	ld a,2
	xor (hl)
	ld (hl),a
	ld c,a
	srl c
	ld hl,36*256+6
	call Menu_Password_BoxOnC
	call Menu_Password_TogglePointer
	call Menu_Password_TogglePointer
	jr Menu_Password_Loop
Menu_Password_ToggleStartup:
	ld hl,(R1+1)
	ld a,4
	xor (hl)
	ld (hl),a
	ld c,a
	srl c
	srl c
	ld hl,44*256+6
	call Menu_Password_BoxOnC
	call Menu_Password_TogglePointer
	call Menu_Password_TogglePointer
	jr Menu_Password_Loop
Menu_Password_MoveDown:
	ld a,(R1)
	cp 4
	jr z,Menu_Password_Loop
	call Menu_Password_TogglePointer
	ld hl,R1
	inc (hl)
	call Menu_Password_TogglePointer
	jr Menu_Password_Loop
Menu_Password_MoveUp:
	ld a,(R1)
	or a
	jr z,Menu_Password_Loop
	call Menu_Password_TogglePointer
	ld hl,R1
	dec (hl)
	call Menu_Password_TogglePointer
	jr Menu_Password_Loop
Menu_Password_TogglePointer:
	ld hl,Menu_Password_TogglePointer_Table
	ld a,(R1)
	ld b,0
	ld c,a
	add hl,bc
	ld a,(hl)
	ld (penrow),a
	ld a,1
	ld (pencol),a
	ld a,(R2)
	xor 3
	ld (R2),a
	B_CALL VPutMap
	ret
Menu_Password_Options:
	DB "Change  password",0 
	DB "Protection:",0
	DB "Apps",0
	DB "Memory",0
	DB "Startup",0
	DB "Programs",0
Password_AppVar:
	DB AppVarObj,"pwdprot"
Menu_Password_TogglePointer_Table:
	DB 0
	DB 27,35,43,51
Menu_Password_BoxOnC:
	srl c
	jr c,Menu_Password_BoxOnC_Filled
	ex de,hl
	ld hl,4*256+4
	add hl,de
	ex de,hl
	push bc
	B_CALL DrawRectBorderClear
	pop bc
	ret
Menu_Password_BoxOnC_Filled:
	ex de,hl
	ld hl,4*256+4
	add hl,de
	ex de,hl
	push bc
	B_CALL FillRect
	pop bc
	ret
Menu_Password_Change:
	B_CALL GrBufClr
	B_CALL ClrLCDFull
	ld hl,0
	ld (pencol),hl
	ld hl,Menu_Password_ChangeMessage
	call vputstr
Menu_Password_Change_Restart:
	call GetPassword
	ld hl,enteredpass
	ld de,thepass
	ld bc,8
	ldir
	B_CALL GrBufClr
	B_CALL ClrLCDFull
	ld hl,0
	ld (pencol),hl
	ld hl,Menu_Password_Confirm
	call vputstr
	call GetPassword
	ld hl,enteredpass
	ld de,thepass
	ld b,8
	call CompareStrings
	jr nz,Menu_Password_No
	ld hl,PasswordFile
	rst 20h
	B_CALL ChkFindSym
	B_CALL DelVarArc
	jp Krolypto_GeneratePassword
Menu_Password_No:
	;The passwords didn't match
	B_CALL GrBufClr
	B_CALL ClrLCDFull
	ld hl,30*256
	ld (pencol),hl
	ld hl,Menu_Password_TryAgain
	call vputstr
	ld de,37*256
	ld (pencol),de
	call vputstr
	jr Menu_Password_Change_Restart
Menu_Password_TryAgain:
	DB "Passwords do not match.",0
	DB "Try again.",0
Menu_Password_ChangeMessage:
	DB "Enter  the  new  password:",0
Menu_Password_Confirm:
	DB "Confirm  the  password:",0
 INCLUDE "hooks.asm"
